VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "FCollection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'    Copyright 2009, 2010 Makarov Andrey
'
'    This file is part of Audica - Open Simple Audio Player.
'
'    Audica is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    Audica is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with Audica.  If not, see <http://www.gnu.org/licenses/>.

Option Explicit
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (lpDest As Any, lpSource As Any, ByVal cBytes&)
Private items As Dictionary
'Private items As Collection
Private k_items(65535) As Long ' ->
Private l_items(65535) As Long ' ->
Private ln As Long
Private f_items(65535) As Long '  
Private fn As Long

Private Sub Class_Initialize()
    Dim i As Long
    Set items = New Dictionary
'    Set items = New Collection
    For i = 0 To 65535
        f_items(i) = 65535 - i
        k_items(i) = -1
    Next i
    fn = 65536
End Sub

Public Sub Add(obj As Object, Optional ByVal before As Long = -1)
    Dim i As Long
    If ln = 65536 Then Err.Raise 1, "FCollection", "No more space"
    decr fn
    If inBounds(before, 0, ln - 1) Then
    'Insert
        For i = before To ln - 1
            incr k_items(l_items(i))
        Next i
        CopyMemory l_items(before + 1), l_items(before), (ln - before) * 4
        l_items(before) = f_items(fn)
        k_items(f_items(fn)) = before
'        items.Add obj, CStr(l_items(before)) ', before '##  ?     ##
    Else
    'Add
        l_items(ln) = f_items(fn)
        k_items(f_items(fn)) = ln
'        items.Add obj, CStr(l_items(ln))
    End If
    items.Add f_items(fn), obj
    incr ln
End Sub

Public Sub Remove(ByVal index As Long)
    Dim i As Long
    If Not inBounds(index, 0, ln - 1) Then Err.Raise 2, "FCollection", "No such an item"
    f_items(fn) = l_items(index)
    k_items(f_items(fn)) = -1
    items.Remove l_items(index)
    If index < ln - 1 Then
        For i = index + 1 To ln - 1
            decr k_items(l_items(i))
        Next i
        CopyMemory l_items(index), l_items(index + 1), (ln - (index + 1)) * 4
    End If
    decr ln
    incr fn
End Sub

Public Property Get Item(ByVal index As Long) As playItem
    If Not inBounds(index, 0, ln - 1) Then Err.Raise 2, "FCollection", "No such an item"
    Set Item = items.Item(l_items(index))
End Property

Public Property Get keyByIndex(ByVal index As Long) As Long
    If inBounds(index, 0, ln - 1) Then
        keyByIndex = l_items(index)
    Else
        keyByIndex = -1
    End If
End Property

Public Property Get indexByKey(ByVal Key As Long) As Long
    indexByKey = -1
    If Not inBounds(Key, 0, 65535) Then Exit Property
    indexByKey = k_items(Key)
End Property

Public Property Get itemByKey(ByVal Key As Long) As playItem
    On Error GoTo 1:
    Set itemByKey = items.Item(Key)
1:
End Property

Public Property Get Count() As Long
    Count = ln
End Property

Public Sub Exchange(ByVal i As Long, ByVal j As Long)
    Dim temp As Long
    k_items(l_items(i)) = j
    k_items(l_items(j)) = i
    temp = l_items(i)
    l_items(i) = l_items(j)
    l_items(j) = temp
End Sub

Public Sub Sort(ByVal key1 As Long, ByVal key2 As Long)
    Dim i As Long, index1 As Long, index2 As Long
    index1 = indexByKey(key1)
    index2 = indexByKey(key2)
    If inBounds(index1, 0, Count - 1) And inBounds(index2, 0, Count - 1) And index1 <> index2 Then
        If index1 > index2 Then
            For i = index2 To index1 - 1
                k_items(l_items(i)) = k_items(l_items(i)) + 1
            Next i
            i = l_items(index1)
            k_items(i) = index2
            CopyMemory l_items(index2 + 1), l_items(index2), (index1 - index2) * 4
            l_items(index2) = i
        Else
            For i = index1 + 1 To index2
                k_items(l_items(i)) = k_items(l_items(i)) - 1
            Next i
            i = l_items(index1)
            k_items(i) = index2
            CopyMemory l_items(index1), l_items(index1 + 1), (index2 - index1) * 4
            l_items(index2) = i
        End If
    Else
        con.WriteLine "Wrong playitem ids to sort: {0} and {1}", d_ERROR, index1, index2
    End If
End Sub
