VERSION 5.00
Begin VB.UserControl ctl_progress 
   AutoRedraw      =   -1  'True
   ClientHeight    =   375
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   FillColor       =   &H000080FF&
   FillStyle       =   0  'Solid
   BeginProperty Font 
      Name            =   "Verdana"
      Size            =   8.25
      Charset         =   204
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ScaleHeight     =   25
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   320
End
Attribute VB_Name = "ctl_progress"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'    Copyright 2009, 2010 Makarov Andrey
'
'    This file is part of Audica - Open Simple Audio Player.
'
'    Audica is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    Audica is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with Audica.  If not, see <http://www.gnu.org/licenses/>.

Option Explicit
Private Declare Function GetCapture Lib "user32.dll" () As Long
Private Declare Function SetCapture Lib "user32.dll" (ByVal hwnd As Long) As Long
Private Declare Function ReleaseCapture Lib "user32.dll" () As Long
Private Type POINTAPI
    X As Long
    Y As Long
End Type
Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type
Private Declare Function ScreenToClient Lib "user32.dll" (ByVal hwnd As Long, ByRef lpPoint As POINTAPI) As Long
Private Declare Function GetCursorPos Lib "user32.dll" (ByRef lpPoint As POINTAPI) As Long
Private Declare Function GetWindowRect Lib "user32.dll" (ByVal hwnd As Long, ByRef lpRect As RECT) As Long
Private Declare Function PtInRect Lib "user32.dll" (ByRef lpRect As RECT, ByVal X As Long, ByVal Y As Long) As Long

Private p_MaxPos As Double
Private rad As Integer 'Radius of O
Private p_position As Double
Private wdth As Single ', Nul As Single
'Private Orient As b
Private driving As Boolean
Public Event PositionSet(ByRef pos As Double, ByRef CursorPos As Double)
Public Event PositionSetByMouse(ByRef pos As Double)
Public Event MouseDown()
Public Event MouseMove(ByRef pos As Double, ByRef CursorPos As Double, ByRef X As Single)
Public Event MouseUp()
Public Event Resize()
Private Colors(3) As Long

Private Sub UserControl_Initialize()
    p_MaxPos = 1
    Colors(0) = &H707070
    Colors(1) = 12632256
    Colors(2) = &H64B1FF '&H80FF& '192
    Colors(3) = 12632256
    FillColor = Colors(2)
    rad = 3
    Call PaintMe
End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
'    Select Case KeyCode
'    Case vbKeyRight:
'        If p_position / p_MaxPos <= 0.99 Then
'            position = p_position + p_MaxPos / 100
'        End If
'    Case vbKeyLeft:
'        If p_position / p_MaxPos >= 0.01 Then
'            position = p_position - p_MaxPos / 100
'        End If
'    End Select
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Call SetCapture(hwnd) 'Anti-Alt+Tab
    driving = True
    RaiseEvent MouseDown
    position = X * p_MaxPos / wdth
    RaiseEvent PositionSetByMouse(p_position)
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Static ox As Single, oy As Single: If ox = X And oy = Y Then Exit Sub
    ox = X: oy = Y
    
    Dim pos As Double
    pos = X * p_MaxPos / wdth
    Call PaintMe
    RaiseEvent MouseMove(pos, CursorOnPos, X)
    If driving And Button = 1 Then
        position = pos
        RaiseEvent PositionSetByMouse(p_position)
        'On Alt+Tab capture wnd is set to 0, and mouseMove is called
        'So we simply call mouseUp here
        If GetCapture <> hwnd Then UserControl_MouseUp Button, Shift, X, Y
    End If
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Call ReleaseCapture 'Anti-Alt+Tab
    driving = False
    RaiseEvent MouseUp
End Sub

Private Sub UserControl_Resize()
    Height = 375
    wdth = ScaleWidth - rad * 2 - 1
    Call PaintMe
    RaiseEvent Resize
    RaiseEvent PositionSet(p_position, CursorOnPos)
End Sub

Private Sub PaintMe()
    Call Cls
    Line (0, ScaleHeight \ 2)-(ScaleWidth, ScaleHeight \ 2), Colors(0)                      '--
    If Enabled Then
        Line (0, ScaleHeight \ 2 - 1)-(Int(wdth * p_position \ p_MaxPos), ScaleHeight \ 2 + 1), Colors(2), BF
        Circle (rad + Int(wdth * p_position \ p_MaxPos), ScaleHeight \ 2), rad, Colors(2)
    End If
End Sub

Public Property Let position(ByVal pos As Double)
    If pos > p_MaxPos Then pos = p_MaxPos Else If pos < 0 Then pos = 0
    p_position = pos
    Call PaintMe
    RaiseEvent PositionSet(p_position, CursorOnPos)
End Property

Public Property Get position() As Double
    position = p_position
End Property

Public Property Let max(ByVal val As Double)
    If val < 1 Then val = 1
    p_MaxPos = val
    Call PaintMe
End Property

Public Property Get max() As Double
    max = p_MaxPos
End Property

Public Property Let enable(ByVal bool As Boolean)
    Enabled = bool
    PaintMe
    If bool Then _
        RaiseEvent PositionSet(position, CursorOnPos)
End Property

Public Property Get enable() As Boolean
    enable = Enabled
End Property

Public Property Get TextWdt(ByRef str As String) As Integer
    TextWdt = TextWidth(str)
End Property

Public Property Get TextHgt(ByRef str As String) As Integer
    TextHgt = TextHeight(str)
End Property

Public Sub renderText(ByVal str As String, Optional ByVal cx As Integer, Optional ByVal cy As Integer, Optional ByVal hcenter As Boolean, Optional ByVal Color As Long = -1, Optional Repaint As Boolean = False)
    If Color <> -1 Then ForeColor = Color
    If hcenter Then _
        cx = wdth \ 2 - TextWidth(str) \ 2
'    cy = ScaleHeight \ 2 - TextHeight(str) \ 2
    prt hdc, str, cx, cy
    If Repaint Then UserControl.Refresh
End Sub

Public Sub Refresh()
    UserControl.Refresh
End Sub

Public Property Let ColorBk(ByVal clr As Long)
    BackColor = clr
    Call PaintMe
End Property

Public Property Let ColorSet(ByVal ind As Byte, ByVal clr As Long)
    If ind > UBound(Colors) Then Exit Property
    If ind = 2 Then FillColor = clr
    Colors(ind) = clr
    Call PaintMe
End Property

Public Function CursorOnPos() As Double
    Dim pt As POINTAPI, rc As RECT
    CursorOnPos = -1
    GetCursorPos pt
    GetWindowRect hwnd, rc
    If PtInRect(rc, pt.X, pt.Y) Then
        ScreenToClient hwnd, pt
        CursorOnPos = pt.X * p_MaxPos / wdth
        If CursorOnPos > p_MaxPos Then CursorOnPos = p_MaxPos 'Cap it.
    End If
End Function

Public Function PosToX(ByRef pos As Double) As Long
    PosToX = pos / (p_MaxPos / wdth)
End Function
