VERSION 5.00
Begin VB.Form con 
   Caption         =   "Console"
   ClientHeight    =   3615
   ClientLeft      =   120
   ClientTop       =   450
   ClientWidth     =   5295
   Icon            =   "fdebug.frx":0000
   LinkTopic       =   "Form2"
   ScaleHeight     =   241
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   353
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "con"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'    Copyright 2009, 2010 Makarov Andrey
'
'    This file is part of Audica - Open Simple Audio Player.
'
'    Audica is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    Audica is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with Audica.  If not, see <http://www.gnu.org/licenses/>.

Option Explicit
Private WithEvents out As Form
Attribute out.VB_VarHelpID = -1
Private binded As Boolean
Private stdout As New Collection
Private section As New Collection
Private Type tprops
    Font As String
    ForeColor As Long
    BackColor As Long
    ScaleMode As Byte
    AutoRedraw As Boolean
End Type
Private psave As tprops

Public Sub bind(ByRef Obj As Form)
If Not binded Then
    Set out = Obj
    
    psave.Font = out.Font
    psave.ForeColor = out.ForeColor
    psave.BackColor = out.BackColor
    psave.ScaleMode = out.ScaleMode
    psave.AutoRedraw = out.AutoRedraw
    
    out.Cls
    out.Font = "Lucida Console"
    out.ForeColor = vbGreen
    out.BackColor = vbBlack
    out.ScaleMode = vbPixels
    out.AutoRedraw = True
    
    Call setLine(linesPerScreen)
    
    binded = True
End If
End Sub

Public Function getBindStatus() As Boolean
    getBindStatus = binded
End Function

Public Sub WriteLine(ByVal strLine As String, ByVal sect As Integer, ParamArray param() As Variant)
If Not binded Then Exit Sub
    Dim i As Integer, str As String
    str = strLine
    For i = 0 To UBound(param())
        If InStr(1, str, "{" & CStr(i) & "}") Then _
            str = Replace$(str, "{" & CStr(i) & "}", param(i))
    Next i
    str = Format$(Minute(time), "00") & ":" & Format$(Second(time), "00") & "> " & str
    Call recordToStdout(str, sect)
    Call printRecord(stdout.Count)
End Sub

Public Sub updateLine(ByVal strLine As String, ByVal sect As Integer, ParamArray param() As Variant)
    Dim i As Integer, str As String
    If stdout.Count > 0 Then stdout.Remove (stdout.Count): section.Remove (section.Count)
    str = strLine
    For i = 0 To UBound(param())
        If InStr(1, str, "{" & CStr(i) & "}") Then _
            str = Replace$(str, "{" & CStr(i) & "}", param(i))
    Next i
    str = Format$(Minute(time), "00") & ":" & Format$(Second(time), "00") & "> " & str
    Call recordToStdout(str, sect)
    Call updateView
End Sub

Public Sub Beep()
If Not binded Then Exit Sub
    Call VBA.Beep
End Sub

Public Sub Clear()
If Not binded Then Exit Sub
    out.Cls
    Call setLine(linesPerScreen)
End Sub

Public Sub break()
If binded Then
'    lineIsBeingRead = False
'/*Restore properties*/
    out.Font = psave.Font
    out.ForeColor = psave.ForeColor
    out.BackColor = psave.BackColor
    out.ScaleMode = psave.ScaleMode
    out.AutoRedraw = psave.AutoRedraw
    Set out = Nothing
'/*Restore properties*/
    binded = False
End If
End Sub

Private Function breakLine(ByRef str As String, ByRef lineCount As Integer, ByVal cpl As Integer) As String
    Dim tmp As String, pos As Integer
    lineCount = 0
    Do
        pos = lineCount * cpl + 1
        tmp = Mid$(str, pos)
        If cpl < Len(tmp) Then
            breakLine = breakLine & Mid$(str, pos, cpl) & vbNewLine
            lineCount = lineCount + 1
        Else
            breakLine = breakLine & tmp
            lineCount = lineCount + 1
            Exit Do
        End If
    Loop
End Function

Private Function breakLine_(ByVal num As Integer, ByVal cpl As Integer) As String
    Dim tmp As String
    tmp = stdout(num)
    Do
        If cpl < Len(tmp) Then
            breakLine_ = breakLine_ & Left$(tmp, cpl) & vbNewLine
        Else
            breakLine_ = breakLine_ & tmp
            Exit Do
        End If
        tmp = Mid$(tmp, cpl + 1)
    Loop
End Function

Private Function countLines(ByVal num As Integer, ByVal cpl As Integer) As Integer
    Dim tmp As String
    tmp = stdout(num)
    Do
        countLines = countLines + 1
        If cpl >= Len(tmp) Then Exit Do
        tmp = Mid$(tmp, cpl + 1)
    Loop
End Function

Private Function charsPerLine() As Integer
    Dim str As String
    str = ".."
    Do
        If out.TextWidth(str) > out.ScaleWidth Then
            charsPerLine = Len(str) - 1
            Exit Do
        Else
            str = str & "."
        End If
    Loop
End Function

Private Sub scrollUpper(ByVal lin_v As Integer)
    Dim buf As New StdPicture, y As Integer
    Set buf = out.Image
    y = currentLine
    out.Cls
    out.PaintPicture buf, 0, -lin_v * lineHeight
    out.CurrentY = (y - lin_v) * lineHeight
End Sub

Private Function lineHeight() As Single
    lineHeight = out.TextHeight("%")
End Function

Private Function linesPerScreen() As Integer
    linesPerScreen = out.ScaleHeight \ lineHeight
End Function

Private Function linesBeforeBorder() As Integer
    linesBeforeBorder = (out.ScaleHeight - out.CurrentY) \ lineHeight
End Function

Private Sub setLine(ByVal num As Integer)
    out.CurrentY = num * lineHeight
End Sub

Private Function currentLine() As Integer
    currentLine = out.CurrentY \ lineHeight
End Function

Private Function lastLine() As Integer
    lastLine = linesPerScreen - 1
End Function

Private Sub recordToStdout(ByVal str As String, ByVal sect As Integer)
    If stdout.Count = (Screen.Height / Screen.TwipsPerPixelY) \ lineHeight Then _
        stdout.Remove 1: section.Remove 1
    stdout.Add str: section.Add sect
End Sub

Private Sub printRecord(ByVal num As Integer)
    Dim str As String, lines As Integer
    str = breakLine(stdout(num), lines, charsPerLine)
    Call scrollUpper(lines)
    Call colour(num)
    out.Print str
End Sub

Private Sub Form_Load()
    bind Me
End Sub

Private Sub updateView()
    Dim lines As Integer, cpl As Integer, i As Integer, j As Integer
    Dim cLines As Integer, str As String
    Call setLine(linesPerScreen)
    If stdout.Count = 0 Then Exit Sub
    cpl = charsPerLine
    Call out.Cls
    For i = stdout.Count To 1 Step -1
        cLines = cLines + countLines(i, cpl)
        If cLines >= linesPerScreen Or i = 1 Then Exit For 'i=1 - otherwise we get i=0 O_o
    Next i
    Call setLine(linesPerScreen - cLines)
    For j = i To stdout.Count
        str = breakLine_(j, charsPerLine)
        Call colour(j)
        out.Print str
    Next j
End Sub

Private Sub colour(ByVal ind As Integer)
    Select Case section(ind)
        Case d_GENERAL: out.ForeColor = vbGreen
        Case d_ERROR: out.ForeColor = vbRed
    End Select
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    If UnloadMode = vbFormControlMenu Then
        Cancel = True
        hide
    End If
End Sub

Private Sub Form_Resize()
    Call updateView
End Sub
