Attribute VB_Name = "global"
'    Copyright 2009, 2010 Makarov Andrey
'
'    This file is part of Audica - Open Simple Audio Player.
'
'    Audica is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    Audica is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with Audica.  If not, see <http://www.gnu.org/licenses/>.

Option Explicit
Private Type msg
    hwnd As Long
    Message As Long
    wParam As Long
    lParam As Long
    time As Long
    ptX As Long
    ptY As Long
End Type
Private Declare Function GetMessage Lib "user32" Alias "GetMessageA" (lpMsg As msg, ByVal hwnd As Long, ByVal wMsgFilterMin As Long, ByVal wMsgFilterMax As Long) As Long
Private Declare Function TranslateMessage Lib "user32" (lpMsg As msg) As Long
Private Declare Function DispatchMessage Lib "user32" Alias "DispatchMessageA" (lpMsg As msg) As Long
Private Declare Function PeekMessage Lib "user32" Alias "PeekMessageA" (lpMsg As msg, ByVal hwnd As Long, ByVal wMsgFilterMin As Long, ByVal wMsgFilterMax As Long, ByVal wRemoveMsg As Long) As Long

Private Declare Function GetWindowThreadProcessId Lib "user32.dll" (ByVal hwnd As Long, ByRef lpdwProcessId As Long) As Long
Public Declare Function CurrentWindow Lib "user32.dll" Alias "GetForegroundWindow" () As Long

Private stack_c As New Collection ' - 

'ICY   
Public Type TYPE_icy
    name As String
    genre As String
    url As String
    bitrate As String
End Type
Private Enum ENUM_tags
    album = 0
    artist = 1
    Comment = 2
    composer = 3
    copyright = 4
    genre = 5
    song = 6
    track = 7
    year = 8
End Enum

Public Enum ENUM_playst
    playing = 1
    invalid = 0
End Enum

Public Enum ENUM_choose
    LINEAR = 0
    RANDOM = 1
End Enum

'CONSOLE
Public Enum ENUM_debug_sections
    d_GENERAL = 0
    d_ERROR = 1
End Enum

Public io As New io

Private Declare Function TextOut Lib "GDI32" Alias "TextOutW" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal s As Long, ByVal nCount As Long) As Long
Private Declare Function DrawText Lib "user32.dll" Alias "DrawTextW" (ByVal hdc As Long, ByVal lpStr As Long, ByVal nCount As Long, ByRef lpRect As RECT, ByVal wFormat As Long) As Long
Public Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type
Public Const DT_RIGHT As Long = &H2
Private Declare Function DefWindowProc Lib "user32" Alias "DefWindowProcW" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Const WM_SETTEXT As Long = &HC
Private Declare Function MultiByteToWideChar Lib "kernel32" (ByVal CodePage As Long, ByVal dwFlags As Long, ByVal lpMultiByteStr As Long, ByVal cchMultiByte As Long, ByVal lpWideCharStr As Long, ByVal cchWideChar As Long) As Long
Private Const CP_UTF8 = 65001

Public Const CREATE_ALWAYS = 2
Public Const OPEN_EXISTING As Long = 3
Public Const INVALID_HANDLE_VALUE = -1
Public Const GENERIC_READ = &H80000000
Public Const FILE_SHARE_READ = &H1

Public Declare Function GetQueueStatus Lib "user32" (ByVal fuFlags As Long) As Long
Public Declare Function GetTickCount Lib "kernel32.dll" () As Long
Public Const REG_EXP_URL As String = "((http|ftp)://)?(([0-9]{1,3}\.){3}[0-9]{1,3}|(www\.)?[^ /\\]+\.[a-z]{2,})(:[0-9]{1,5})?(/[^ ]*)?"
Private rxObj As New RegExp
Private rxMatchCol As MatchCollection

Public Type POINTAPI
    x As Long
    y As Long
End Type

'  
Public Sub prt(ByVal hdc As Long, ByRef str As String, ByVal x As Long, ByVal y As Long)
    TextOut hdc, x, y, StrPtr(str), Len(str)
End Sub

Public Sub prtf(ByVal hdc As Long, ByVal str As String, ByRef rc As RECT, Optional ByVal fmt As Long, Optional ByVal calc As Boolean)
    'DT_NOPREFIX = &H800 '&
    'DT_WORD_ELLIPSIS = &H40000 '...
    'DT_CALCRECT = &H400 'Calc
    Call DrawText(hdc, StrPtr(str), Len(str), rc, IIf(calc, &H400, fmt Or &H40000 Or &H800))
End Sub

Public Property Let uni_caption(ByVal hwnd As Long, ByRef str As String)
    DefWindowProc hwnd, WM_SETTEXT, 0, ByVal StrPtr(str)
End Property

' p2  p1      
Public Function b(p1 As Long, p2 As Long) As Boolean
    p1 = p2
    b = CBool(p1)
End Function

'  text    ,   
Public Function s(Optional prefix As String = vbNullString, Optional Text As String = vbNullString, Optional postfix As String = vbNullString, Optional def As String = vbNullString) As String
    If LenB(Text) <> 0 Then s = prefix & Text & postfix Else s = def
End Function

' prefix  postfix  middle,   
Public Function s2(Optional prefix As String = vbNullString, Optional middle As String = vbNullString, Optional postfix As String = vbNullString) As String
    If LenB(prefix) <> 0 And LenB(postfix) <> 0 Then _
        s2 = prefix & middle & postfix _
    Else s2 = prefix & postfix
End Function

Public Function inBounds(ByVal v As Long, ByVal low As Long, ByVal high As Long) As Boolean
    If v >= low And v <= high Then inBounds = True
End Function

'    qt4)
Public Sub qDebug(ParamArray Text() As Variant)
    Dim i As Integer, str As String
    For i = 0 To UBound(Text())
        str = str & Text(i) & IIf(i <> UBound(Text()), "::", "")
    Next i
'    Debug.Print str
    con.WriteLine str, d_GENERAL
End Sub

Public Sub qError(ParamArray Text() As Variant)
    Dim i As Integer, str As String
    For i = 0 To UBound(Text())
        str = str & Text(i) & IIf(i <> UBound(Text()), "::", "")
    Next i
    con.WriteLine str, d_ERROR
End Sub

' 
Public Function iterate(ByRef var, ByVal max As Long, Optional rev As Boolean = False) As Long
    If Not rev Then _
        var = IIf(var >= max, 0, var + 1) _
    Else var = IIf(var <= 0, max, var - 1)
    iterate = var
End Function

'     
Public Function inc(ByRef var As Integer) As Integer
    If var < 32767 Then _
        var = var + 1
    inc = var
End Function

Public Function incr(ByRef var As Long) As Long
    var = var + 1
    incr = var
End Function

'     
Public Function decr(ByRef var As Long) As Long
    var = var - 1
    decr = var
End Function

'  VB IDE?
Public Function inIDE() As Boolean
On Error GoTo 1:
    Debug.Print 1 / 0
Exit Function
1:  inIDE = True
End Function

Public Sub DoEvents_()
    If GetQueueStatus(255) Then DoEvents
End Sub

'Public Sub DoEvents__()
'    Dim TMsg As msg
'    Do While PeekMessage(TMsg, 0&, 0&, 0&, 1)
'        Select Case TMsg.Message
'        Case &H200 To &H20E, &H100 To &H108:
'            TranslateMessage TMsg
'            DispatchMessage TMsg
'        End Select
'    Loop
'End Sub

Public Sub DoPaintEvents()
    Dim TMsg As msg
    Do While PeekMessage(TMsg, 0&, 0&, 0&, 1)
        If TMsg.Message = &HF Then
            TranslateMessage TMsg
            DispatchMessage TMsg
        End If
    Loop
End Sub

Public Function getRandomList(ByVal num As Long) As Long()
    Dim lst() As Long, i As Long, j As Long
    If num > 0 Then
        ReDim lst(0 To num - 1)
        For i = 0 To num - 1
            j = Int(Rnd * (i + 1))
            lst(i) = lst(j)
            lst(j) = i
        Next i
    End If
    getRandomList = lst
End Function

Public Function findValueInList(ByVal value As Long, ByRef arr() As Long) As Long
    Dim i As Long, Index As Long, uub As Long
    findValueInList = -1
    uub = UUBound(arr)
    For i = 0 To uub
        If arr(i) = value Then
            findValueInList = i
            Exit Function
        End If
    Next i
End Function

Public Function checkRegExpMask(ByRef strText As String, ByRef strSearch As String, Optional ByVal CompareMode As VbCompareMethod) As Boolean
On Error GoTo 1:
    rxObj.IgnoreCase = (CompareMode = vbTextCompare)
    rxObj.global = True
    rxObj.MultiLine = True
    rxObj.Pattern = strSearch
'    checkRegExpMask = rxObj.Execute(strText).count > 0
    Set rxMatchCol = rxObj.Execute(strText)
    If rxMatchCol.Count = 1 Then _
        If strText = rxMatchCol(0).value Then _
            checkRegExpMask = True
Exit Function
1: qDebug "ERROR in checkRegExpMask", Now
End Function
'
'Public Function findByRegExpMask(ByRef strText As String, ByRef strSearch As String, Optional ByVal CompareMode As VbCompareMethod) As String
'On Error GoTo 1:
'    rxObj.IgnoreCase = (CompareMode = vbTextCompare)
'    rxObj.global = True
'    rxObj.MultiLine = True
'    rxObj.Pattern = strSearch
'    Set rxMatchCol = rxObj.Execute(strText)
'    If rxMatchCol.count > 0 Then _
'        findByRegExpMask = rxMatchCol(1).Value
'Exit Function
'1: qDebug "ERROR in findByRegExpMask", Now
'End Function

'Get long number from 4 bytes array
'X0000000 X0000000 X0000000 X0000000 - X bits are ignored
'High (0)      (1)      (2) Low  (3)
Private Function get28bitId3Size(ByRef cval() As Byte) As Long
    Dim bytes(3) As Long
    bytes(0) = cval(3) And &H7F
    bytes(1) = (cval(2) And &H7F And &HFFFFFF) * &H80
    bytes(2) = (cval(1) And &H7F And &H1FFFF) * &H4000
    bytes(3) = (cval(0) And &H7F And &H3FF) * &H200000
    get28bitId3Size = bytes(3) + bytes(2) + bytes(1) + bytes(0)
End Function

Private Function get32bitDataSize(ByRef cval() As Byte) As Long
    Dim bytes(3) As Long
    bytes(0) = cval(3)
    bytes(1) = (cval(2) And &H7FFFFF) * &H100
    bytes(2) = (cval(1) And &H7FFF) * &H10000
    bytes(3) = (cval(0) And &H7F) * &H1000000
    get32bitDataSize = bytes(3) + bytes(2) + bytes(1) + bytes(0)
End Function

Public Function getId3AlbumArt(ByVal Handle As Long, Optional filePath As String) As Long
On Error GoTo 1:
    Dim id3Ptr As Long, id3hdr(9) As Byte, pos As Long, pos2 As Long, id3len As Long
    Dim apiclen As Long, Picture() As Byte
    id3Ptr = BASS_ChannelGetTags(Handle, BASS_TAG_ID3V2)
    If id3Ptr Then
        CopyMemory id3hdr(0), ByVal id3Ptr, 10
        If checkMagicRecord(id3hdr, "ID3", pos) Then 'Check MAGIC
            If id3hdr(pos) <= 4 Then 'Check version
                incr pos
                incr pos 'Skip revision number byte
                incr pos 'Skip flags byte
                If b(id3len, get28bitId3Size(midFromArr(id3hdr, pos, 4))) Then
                    ReDim id3bdy(id3len - 1) As Byte
                    CopyMemory id3bdy(0), ByVal id3Ptr + 10, id3len
                    If b(pos, findBytesInArray(id3bdy, 0, "A", "P", "I", "C")) Then
                        pos = (pos - 1) + 4
                        If b(apiclen, get32bitDataSize(midFromArr(id3bdy, pos, 4))) Then
                            pos = pos + 2 'Skip flags bytes
                            pos2 = pos 'Start of APIC frame data
                            incr pos 'Skip text encoding byte
                            If b(pos, findBytesInArray(id3bdy, pos, vbNullChar)) Then
                                incr pos 'Skip picture type byte
                                If b(pos, findBytesInArray(id3bdy, pos, vbNullChar)) Then
                                    'pos = Start of picture data
                                    'pos - pos2 = Bytes between begin of frame and picture data
                                    Picture = midFromArr(id3bdy, pos, apiclen - (pos - pos2))
'                                    Open "C:\pict.jpg" For Binary Access Write As #1
'                                    Put #1, , Picture
'                                    Close #1
                                    If b(getId3AlbumArt, FreeImage_LoadFromMemoryEx(Picture)) Then _
                                        qDebug "Picture loaded from ID3V2"
                                End If
                            End If
                        End If
                    End If
                End If
            End If
        End If
    End If
    If getId3AlbumArt = 0 And LenB(filePath) <> 0 Then
'        filePath = Left$(filePath, Len(filePath) - 1)
        'Search for cover.jpg, cover.jpeg, cover.png, cover.gif, cover.bmp
        Call io.enumFiles(filePath, "cover\.(jpg|jpeg|png|gif|bmp)")
        If io.filesResult.Count Then
            If b(getId3AlbumArt, FreeImage_LoadEx(io.filesResult(1))) Then _
                qDebug "Cover picture loaded from folder"
        Else
            Call io.enumFiles(filePath, ".*AlbumArt.*\.(jpg|jpeg|png|gif|bmp)")
            If io.filesResult.Count Then
                If b(getId3AlbumArt, FreeImage_LoadEx(io.filesResult(1))) Then _
                    qDebug "Album art loaded from folder"
            End If
        End If
    End If
Exit Function
1:  If Err.Source = "FreeImage" And Err.Number = 481 Then 'Invalid picture
        qError "Load cover picture", Err.Description
    End If
End Function

Public Function getStreamTags(Handle As Long) As playItem
    Dim info As BASS_CHANNELINFO, tagstr As String
    ReDim Tag(8) As String '   ,   
    tagstr = VBStrFromAnsiPtr(TAGS_Read(Handle, "%UTF8(%IFV1(%ALBM,%ALBM)~*%IFV1(%ARTI,%ARTI)~*%IFV1(%CMNT,%CMNT)~*%IFV1(%COMP,%COMP)~*%IFV1(%COPY,%COPY)~*%IFV1(%GNRE,%GNRE)~*%IFV1(%TITL,%TITL)~*%IFV1(%TRCK,%TRCK)~*%YEAR)"))
    Set getStreamTags = New playItem
    If LenB(tagstr) <> 0 Then
        tagstr = dec_UTF8(tagstr)
        Tag = Split(tagstr, "~*")
        getStreamTags.album = Tag(album)
        getStreamTags.artist = Tag(artist)
        getStreamTags.Comment = Tag(Comment)
        getStreamTags.composer = Tag(composer)
        getStreamTags.copyright = Tag(copyright)
        getStreamTags.genre = Tag(genre)
        getStreamTags.song = Tag(song)
        getStreamTags.track = Tag(track)
        getStreamTags.year = Tag(year)
    End If
    getStreamTags.gotTags = True
End Function

Public Function getFileInfo(Handle As Long) As playItem
    Dim info As BASS_CHANNELINFO
    Set getFileInfo = New playItem
    If BASS_ChannelGetInfo(Handle, info) = BASSTRUE Then
        getFileInfo.channels = info.chans
        getFileInfo.frequency = info.freq
        getFileInfo.ctype = info.ctype
        getFileInfo.Plugin = info.Plugin
    End If
End Function

Rem ///////////////////////////////////////////////////////
'Remarks BASS_ChannelGetTags
'ID3v1 tags are located at the end of the file, so when streaming a file with ID3v1
'tags from the internet, the tags will not be available until the download is complete.
'A BASS_SYNC_DOWNLOAD sync can be set via BASS_ChannelSetSync, to be informed of when
'the download is complete. A BASS_SYNC_META sync can be used to be informed of new
'Shoutcast metadata, and a BASS_SYNC_OGG_CHANGE sync for when a new logical bitstream
'begins in a chained OGG stream, which generally brings new OGG tags.


'' Save the current values.
'Public Sub addItemToDoc(ByVal sect As String, ByRef item As playItem, ByRef node As IXMLDOMNode)
'    Dim subnode As IXMLDOMNode
'    Set subnode = node.ownerDocument.createElement(sect)
'    With item
'    subnode.Text = .artist & ";" & vbTab & _
'                    .song & ";" & vbTab & _
'                    IIf(.gotTags, "1", "0") & ";" & vbTab & _
'                    .file & ";" & vbTab & _
'                    CStr(.tlen) & ";" & vbTab & _
'                    CStr(.flen) & ";" & vbTab & _
'                    IIf(.remote, "1", "0")
'    End With
'    node.appendChild subnode
'End Sub
'
'Public Function getFirstItemXml(ByRef subnode As IXMLDOMNode, ByRef node As IXMLDOMNode) As playItem
'    Dim str() As String
'    Set subnode = node.firstChild
'    If subnode Is Nothing Then Exit Function
'    str = Split(subnode.Text, ";" & vbTab)
'    If UBound(str) <> 6 Then Exit Function
'    Set getFirstItemXml = New playItem
'    With getFirstItemXml
'    .artist = str(0)
'    .song = str(1)
'    .gotTags = IIf(str(2) = "1", True, False)
'    .file = str(3)
'    .tlen = Val(str(4))
'    .flen = Val(str(5))
'    .remote = IIf(str(6) = "1", True, False)
'    End With
'End Function
'
'Public Function getNextItemXml(ByRef subnode As IXMLDOMNode) As playItem
'    Dim str() As String
'    Set subnode = subnode.nextSibling
'    If subnode Is Nothing Then Exit Function
'    str = Split(subnode.Text, ";" & vbTab)
'    If UBound(str) <> 6 Then Exit Function
'    Set getNextItemXml = New playItem
'    With getNextItemXml
'    .artist = str(0)
'    .song = str(1)
'    .gotTags = IIf(str(2) = "1", True, False)
'    .file = str(3)
'    .tlen = Val(str(4))
'    .flen = Val(str(5))
'    .remote = IIf(str(6) = "1", True, False)
'    End With
'End Function

'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'    Dim node As IXMLDOMNode, subnode As IXMLDOMNode, item As playItem
'    Set node = loadXMLDoc(AppPath & Path)
'    If node Is Nothing Then Exit Sub
'    Call populationStart
'    Set item = getFirstItemXml(subnode, node)
'    If Not item Is Nothing Then
'        Do
'            playlist.add item
'            List.AddItem ""
'            updateListItem List.count - 1 '  
'            Set item = getNextItemXml(subnode)
'            If item Is Nothing Then Exit Do
'        Loop
'    End If
'    Call populationFinish
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

'Find first occurrence from position /po/ of /bytes/ array in /arr/ array
'returns 1 based value, right?)
Public Function findBytesInArray(ByRef arr() As Byte, ByVal pos As Long, ParamArray bytes()) As Long
    If pos > UUBound(arr) Or UBound(bytes()) < 0 Then
        findBytesInArray = -1
        Exit Function
    End If
    ReDim arr2(UBound(bytes)) As Byte
    Dim i As Integer, uub As Integer
    uub = UUBound(arr2)
    For i = 0 To uub
        arr2(i) = Asc(bytes(i))
    Next i
    incr pos
    findBytesInArray = InStrB(pos, arr, arr2)
End Function

'     (  8 )
'true, true, false -> 0000 0110
Public Function bitsToByte(ParamArray param() As Variant) As Byte()
    Dim i As Byte, dat(0) As Byte
    For i = 0 To UBound(param())
        If param(i) Then dat(0) = dat(0) + 2 ^ (UBound(param()) - i)
    Next i
    bitsToByte = dat
End Function

' bitsToByte 
Public Function byteToBits(ByRef data() As Byte, ByRef pos As Long) As Boolean()
    Dim i As Byte, inp() As Byte, arr(7) As Boolean
    inp = midFromArr(data, pos, 1)
    For i = 0 To 7
        arr(i) = inp(0) And 2 ^ i
    Next i
    byteToBits = arr
End Function

'Public Function boolToByte(ByRef bool As Boolean) As Byte()
'    Dim arr(0) As Byte
'    If bool Then arr(0) = 1
'    boolToByte = arr
'End Function

'Convert Long into array of bytes
Public Function lngToByte(ByRef lng As Long) As Byte()
    Dim arr(3) As Byte
    CopyMemory arr(0), ByVal VarPtr(lng), 4
    lngToByte = arr
End Function

'Read lng from pos in byte array
Public Function byteToLng(ByRef lng() As Byte, ByRef pos As Long) As Long
    CopyMemory ByVal VarPtr(byteToLng), lng(pos), 4
    pos = pos + 4
End Function
 
'Write byte array to pos in byte array
Public Sub copyToArr(ByRef arrTo() As Byte, ByRef arrFrom() As Byte, ByRef pos As Long)
    Dim bytes As Long
    bytes = UBound(arrFrom) + 1
    CopyMemory arrTo(pos), arrFrom(0), bytes
    pos = pos + bytes
End Sub
 
'Mid byte array from byte array
Public Function midFromArr(ByRef arrFrom() As Byte, ByRef pos As Long, ByVal bytes As Long) As Byte()
    If bytes = 0 Then Exit Function
    
    Dim n As Long '     
    n = UBound(arrFrom()) + 1 - pos
    If bytes > n And n > 0 Then bytes = UBound(arrFrom()) + 1 - pos
    
    ReDim arrTo(bytes - 1) As Byte
    CopyMemory arrTo(0), arrFrom(pos), bytes
    midFromArr = arrTo
    pos = pos + bytes
End Function

'Reads a string from array
'|len|string|
Public Function readStrFromArr(ByRef arrFrom() As Byte, ByRef pos As Long) As String
    Dim intg As Integer
    intg = byteToInt(arrFrom, pos)
    If pos + intg - 1 > UBound(arrFrom) Or intg < 0 Then Exit Function
    readStrFromArr = midFromArr(arrFrom, pos, intg)
End Function

'Write str to pos in byte array
Public Sub strToArr(ByRef arrTo() As Byte, ByRef str As String, ByRef pos As Long)
    Dim bytes As Long
    bytes = LenB(str)
    If bytes = 0 Then Exit Sub
    CopyMemory arrTo(pos), ByVal StrPtr(str), bytes
    pos = pos + bytes
End Sub

'Write int to pos in byte array
Public Sub intToArr(ByRef arrTo() As Byte, ByRef intg As Integer, ByRef pos As Long)
    CopyMemory arrTo(pos), ByVal VarPtr(intg), 2
    pos = pos + 2
End Sub

'Read int from pos in byte array
Public Function byteToInt(ByRef intg() As Byte, ByRef pos As Long) As Integer
    CopyMemory ByVal VarPtr(byteToInt), intg(pos), 2
    pos = pos + 2
End Function

'Write lng to pos in byte array
Public Sub lngToArr(ByRef arrTo() As Byte, ByRef lng As Long, ByRef pos As Long)
    CopyMemory arrTo(pos), ByVal VarPtr(lng), 4
    pos = pos + 4
End Sub

'Reads bool from array
Public Function readBoolFromArr(ByRef dat() As Byte, ByRef pos As Long) As Boolean
    readBoolFromArr = dat(pos)
    pos = pos + 1
End Function

Public Function checkMagicRecord(ByRef arr() As Byte, ByVal magic As String, ByRef pos As Long) As Boolean
    Dim i As Integer
    checkMagicRecord = True
    For i = 0 To Len(magic) - 1
        If arr(i) <> Asc(Mid$(magic, i + 1, 1)) Then checkMagicRecord = False
    Next i
    pos = pos + Len(magic)
End Function

'Conversion UTF-8 -> UTF-16
Public Function dec_UTF8(ByRef str As String) As String
    Dim stBuffer As String, cwch As Long, dat() As Byte
    If LenB(str) Then
        dat = StrConv(str, vbFromUnicode)
        ReDim Preserve dat(UUBound(dat) + 1)
        cwch = MultiByteToWideChar(CP_UTF8, 0, VarPtr(dat(0)), -1, 0&, 0&)
        stBuffer = String$(cwch + 1, vbNullChar)
        cwch = MultiByteToWideChar(CP_UTF8, 0, VarPtr(dat(0)), -1, StrPtr(stBuffer), Len(stBuffer))
        dec_UTF8 = Left$(stBuffer, cwch - 1)
    End If
End Function

'Conversion UTF-8 -> UTF-16
'Removes utf-8 identification sequence: EFBBBF
Public Function dec_UTF8_arr(ByRef srcdat() As Byte) As String
    Dim stBuffer As String, cwch As Long, Count As Long, offset As Long
    If b(Count, UUBound(srcdat) + 1) Then
        If Count > 2 Then If srcdat(0) = &HEF And srcdat(1) = &HBB And srcdat(2) = &HBF Then offset = 3
        ReDim dat(Count - offset)
        CopyMemory dat(0), srcdat(offset), Count - offset
        cwch = MultiByteToWideChar(CP_UTF8, 0, VarPtr(dat(0)), -1, 0&, 0&)
        stBuffer = String$(cwch + 1, vbNullChar)
        cwch = MultiByteToWideChar(CP_UTF8, 0, VarPtr(dat(0)), -1, StrPtr(stBuffer), Len(stBuffer))
        dec_UTF8_arr = Left$(stBuffer, cwch - 1)
    End If
End Function

Public Sub StackPush(ByRef v As Variant)
    stack_c.Add v
End Sub

Public Function StackPop() As Variant
    If stack_c.Count > 0 Then
        StackPop = stack_c(stack_c.Count)
        stack_c.Remove stack_c.Count
    Else
        StackPop = -1
    End If
End Function

Public Function bits(ByVal val As Long, ByVal Flags As Long) As Boolean
    If (val And Flags) = Flags Then bits = True
End Function

'true - if foreground window belongs to app's thread
Public Function ProcessOnTop() As Boolean
    ProcessOnTop = (GetWindowThreadProcessId(CurrentWindow, 0) = App.ThreadID)
End Function
