Attribute VB_Name = "kbd"
'    Copyright 2009, 2010 Makarov Andrey
'
'    This file is part of Audica - Open Simple Audio Player.
'
'    Audica is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    Audica is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with Audica.  If not, see <http://www.gnu.org/licenses/>.

Option Explicit
Private Declare Function GetAsyncKeyState Lib "user32.dll" (ByVal vKey As Long) As Integer
Private kbdmap(255) As Boolean
Public Const KBD_PLAYPAUSE As Byte = 179
Public Const KBD_STOP As Byte = 178
Public Const KBD_REW As Byte = 177
Public Const KBD_FF As Byte = 176
Public Const KBD_LSHIFT As Byte = 160
Public Const KBD_RSHIFT As Byte = 161
Public Const KBD_LCTRL As Byte = 162
Public Const KBD_RCTRL As Byte = 163
Public Const KBD_LALT As Byte = 164
Public Const KBD_RALT As Byte = 165
Private Const VK_SHIFT = &H10
Private Const VK_CONTROL = &H11
Private Const VK_MENU = &H12
Public kbd_presses As Boolean

Private Declare Function DeviceIoControl Lib "kernel32.dll" (ByVal hDevice As Long, ByVal dwIoControlCode As Long, ByRef lpInBuffer As Any, ByVal nInBufferSize As Long, ByRef lpOutBuffer As Any, ByVal nOutBufferSize As Long, ByRef lpBytesReturned As Long, ByRef lpOverlapped As Long) As Long
Private Type KEYBOARD_INDICATOR_PARAMETERS
    UnitId As Integer
    LedFlags As Integer
End Type
Private Const IOCTL_KEYBOARD_QUERY_INDICATORS As Long = &HB0040
Private Const IOCTL_KEYBOARD_SET_INDICATORS As Long = &HB0008
Private Declare Function DefineDosDevice Lib "kernel32.dll" Alias "DefineDosDeviceA" (ByVal dwFlags As Long, ByVal lpDeviceName As String, ByVal lpTargetPath As String) As Long
Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Long, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Private Const OPEN_EXISTING As Long = 3
Private Const GENERIC_WRITE As Long = &H40000000
Private Const DDD_RAW_TARGET_PATH As Long = &H1
Private Const DDD_REMOVE_DEFINITION As Long = &H2
Private Declare Function CloseHandle Lib "kernel32.dll" (ByVal hObject As Long) As Long
Private Declare Function GetKeyboardState Lib "user32" (pbKeyState As Byte) As Long
Private Const VK_NUMLOCK = &H90 'NumLock
Private Const VK_CAPITAL = &H14 'CapsLock
Private Const VK_SCROLL = &H91  'ScrollLock
Private kbd As Long

Public Function kbdKeyPush(ByRef Key As Byte) As Boolean
    If (GetAsyncKeyState(Key) And -32767) = -32767 Then kbdKeyPush = True
End Function

Public Function kbdKeyHold(ByRef Key As Byte) As Boolean
    If (GetAsyncKeyState(Key) And -32768) = -32768 Then kbdKeyHold = True
End Function

'Like kbdKeyPush but returns \true\ only 1 time per press for any key
Public Function kbdKeyOnce(ByRef Key As Byte) As Boolean
    If (GetAsyncKeyState(Key) And -32768) = -32768 Then
        If Not kbdmap(Key) Then kbdKeyOnce = True
        kbdmap(Key) = True
    Else
        kbdmap(Key) = False
    End If
End Function

Public Function kbdAnyKeyPush() As Boolean
    Dim kbd_map(255) As Byte, i As Integer, str As String
    GetKeyboardState kbd_map(0)
    For i = 0 To 255
        If (kbd_map(i) And 128) = 128 Then
            Debug.Print i
            kbdAnyKeyPush = True
            Exit Function
        End If
    Next i
End Function

'Get state of ALT, SHIFT and CTRL
Public Function getModificators() As Byte
    If kbdKeyHold(VK_SHIFT) Then getModificators = vbShiftMask
    If kbdKeyHold(VK_CONTROL) Then getModificators = getModificators Or vbCtrlMask
    If kbdKeyHold(VK_MENU) Then getModificators = getModificators Or vbAltMask
End Function

'Public Function whichIsPressed() As String
'    Dim i As Integer, k As Integer
'    For i = 0 To 255
'        k = GetAsyncKeyState(i)
'        If k Then whichIsPressed = whichIsPressed & Hex$(i) & "-" & ByteToBit07(k) & " "
'    Next i
'End Function
'
'Public Function ByteToBit07(b As Integer) As String
'' by Donald, donald@xbeat.net, 20001221
'  Dim i As Long
'  Dim bit As Long
'
'  ByteToBit07 = "0000000000000000"
'  bit = 1
'
'  For i = 16 To 1 Step -1
'    If b And bit Then Mid$(ByteToBit07, i, 1) = "1"
'    bit = bit * 2
'  Next
'
'End Function


Public Function restoreLEDs() As Boolean
'Set real LED states (according to key states)
    Dim st(255) As Byte
    If kbd = 0 Then Exit Function
    GetKeyboardState st(0)
    restoreLEDs = setLEDs(st(VK_SCROLL), st(VK_NUMLOCK), st(VK_CAPITAL))
End Function

Public Function setLEDs(ByVal scrl As Boolean, ByVal num As Boolean, ByVal caps As Boolean) As Boolean
    Dim buf As KEYBOARD_INDICATOR_PARAMETERS
    Dim ret As Long 'return length
    If kbd = 0 Then Exit Function
    buf.LedFlags = IIf(scrl, 1, 0) Or IIf(num, 2, 0) Or IIf(caps, 4, 0)
    If DeviceIoControl(kbd, IOCTL_KEYBOARD_SET_INDICATORS, buf, Len(buf), _
        Null, 0, ret, ByVal 0) <> 0 Then setLEDs = True
End Function

'Private Function queryLEDs(ByRef scrl As Boolean, ByRef num As Boolean, ByRef caps As Boolean) As Boolean
'    Dim buf As KEYBOARD_INDICATOR_PARAMETERS    ' Input buffer for DeviceIoControl
'    Dim ret As Long 'return length
'    If kbd = 0 Then Exit Function
'    If DeviceIoControl(kbd, IOCTL_KEYBOARD_QUERY_INDICATORS, Null, 0, _
'        buf, Len(buf), ret, ByVal 0) <> 0 Then queryLEDs = True
'    scrl = (buf.LedFlags And 1)
'    num = (buf.LedFlags And 2)
'    caps = (buf.LedFlags And 4)
'End Function

Public Function OpenKeyboardDevice() As Boolean
    If DefineDosDevice(DDD_RAW_TARGET_PATH, "Kbd", "\Device\KeyboardClass0") = 0 Then Exit Function
    kbd = CreateFile("\\.\Kbd", GENERIC_WRITE, 0, ByVal 0, OPEN_EXISTING, 0, 0)
    If kbd = -1 Then kbd = 0 '-1   -    
    OpenKeyboardDevice = (kbd = True)
End Function

Public Function CloseKeyboardDevice() As Long
    restoreLEDs
    CloseKeyboardDevice = CloseHandle(kbd)
    kbd = 0
    DefineDosDevice DDD_REMOVE_DEFINITION, "Kbd", "" '   -
End Function

Public Property Get LEDControl() As Boolean
    LEDControl = (kbd <> 0)
End Property


