VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "lastFM"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'    Copyright 2009, 2010 Makarov Andrey
'
'    This file is part of Audica - Open Simple Audio Player.
'
'    Audica is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    Audica is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with Audica.  If not, see <http://www.gnu.org/licenses/>.

Option Explicit

'Class implementing
'Last.fm Submissions Protocol v1.2.1
'Written according to
'http://www.lastfm.ru/api/submissions
'Winand, 2009 (started 09-09-14)

Private Declare Sub GetSystemTime Lib "kernel32.dll" (ByRef lpSystemTime As SYSTEMTIME)
Private Type SYSTEMTIME
    wYear As Integer
    wMonth As Integer
    wDayOfWeek As Integer
    wDay As Integer
    wHour As Integer
    wMinute As Integer
    wSecond As Integer
    wMilliseconds As Integer
End Type

Private Const CP_UTF8 = 65001
Private Declare Function WideCharToMultiByte Lib "kernel32.dll" (ByVal CodePage As Long, ByVal dwFlags As Long, _
    ByVal lpWideCharStr As Long, ByVal cchWideChar As Long, ByRef lpMultiByteStr As Any, ByVal cbMultiByte As Long, _
    ByRef lpDefaultChar As Any, ByRef lpUsedDefaultChar As Long) As Long
Private percentMap(0 To 255) As String

Private WithEvents http As WinHttpRequest 'For handshake and now-playing
Attribute http.VB_VarHelpID = -1
Private WithEvents httpSb As WinHttpRequest 'For scrobbling
Attribute httpSb.VB_VarHelpID = -1
Private WithEvents clock As Timer   '          - 
Attribute clock.VB_VarHelpID = -1
Private clk_int As Integer  '-   ()
Private clk_tick As Integer ' 

Private Const DEFAULT_HSURL As String = "http://post.audioscrobbler.com"
Private Const DEFAULT_CLIENT As String = "tst"
Private Const DEFAULT_CLIENTVER As String = "1.0"
Private Enum stat_enum
    MUSTHANDSHAKE = 0 'haven't handshaked
    HANDSHAKING = 1 'handshaking now
    WILLHANDSHAKE = 2 'will handshake after some time
    CONNECTED = 3 'handshaked successfully
    CANNOTCONNECT = 4 'handshake's impossible, e.g. wrong password, prefs not set

    NP_NOACTION = 0
    NPPOSTING = 1 'posting now-playing now
    
    SB_NOACTION = 0
    SCROBBLING = 1 'scrobbling now, SCROBBLING+1 - 2nd attempt SCROBBLING+2 - 3nd attempt
End Enum
Private Status_hs As Byte
Private Status_np As Byte
Private Status_sb As Byte
Private Type ident_type
    user As String      'User login
    md5pass As String   'MD5 of user pass
End Type
Private id As ident_type
Private Type handshake_type
    sessionID As String 'Session ID, got after hanshake
    nowPlayingURL As String 'URL to send now-playing songs
    scrobblingURL As String 'URL to send songs for scrobbling
End Type
Private hs As handshake_type
Private Type service_type
    hsURL As String 'Handshake URL
    hsUTC As Boolean 'Send handshake with UTC timestamp (or local time)
    client As String 'Client identificator
    clientV As String 'Client version
End Type
Private serv As service_type    ' setPrefs   url  ,    
                                '.  DEFAULT_HSURL, DEFAULT_CLIENT, DEFAULT_CLIENTVER
Private queue As New Collection '.  ,    
Private queueToQueue As New Collection '    queue,      
                                        '- - , )
                                        '      2     ?
                                        '- ... ??
Private Const QUEUE_CACHE_FILE As String = "cache.txt"
Private Const MAGIC_CH As String = "CH$"
Private disabled As Boolean '    .   isEnabled
Event response(ByRef msg As String)
Event error(ByRef msg As String, ByVal disabled As Boolean)
Event dbgMsg(ByRef msg As String)

'  
Private Function createHSQuery(ByVal user As String, ByVal md5pass As String) As String
    Const LAST_FM_HS_REQUEST As String = _
        "hs=true&p=1.2.1&c=<client-id>&v=<client-ver>&u=<user>&t=<timestamp>&a=<auth>"
    Dim timestamp As Long
    timestamp = IIf(serv.hsUTC, UNIXTimeUTC, UNIXTime)
    createHSQuery = LAST_FM_HS_REQUEST
    createHSQuery = Replace$(createHSQuery, _
        "<client-id>", serv.client)
    createHSQuery = Replace$(createHSQuery, _
        "<client-ver>", serv.clientV)
    createHSQuery = Replace$(createHSQuery, _
        "<user>", user)
    createHSQuery = Replace$(createHSQuery, _
        "<timestamp>", timestamp)
    createHSQuery = Replace$(createHSQuery, _
        "<auth>", md5(md5pass & timestamp))
End Function

'  Now-playing
Private Function createNPQuery(ByVal session As String, ByVal artist As String, ByVal song As String, _
                                Optional ByVal album As String, Optional ByVal secs As Long, _
                                Optional ByVal no As String, Optional ByVal mbid As String) As String
    Const LAST_FM_NP_QUERY As String = _
        "s=<sessionID>&a=<artistname>&t=<track>&b=<album>&l=<secs>&n=<tracknumber>&m=<mb-trackid>"
    createNPQuery = LAST_FM_NP_QUERY
    createNPQuery = Replace$(createNPQuery, "<sessionID>", session)
    createNPQuery = Replace$(createNPQuery, "<artistname>", pe(artist))
    createNPQuery = Replace$(createNPQuery, "<track>", pe(song))
    createNPQuery = Replace$(createNPQuery, "<album>", pe(album))
    createNPQuery = Replace$(createNPQuery, "<secs>", secs)
    createNPQuery = Replace$(createNPQuery, "<tracknumber>", no)
    createNPQuery = Replace$(createNPQuery, "<mb-trackid>", mbid)
End Function

' -.       queue
Private Function createSBQuery(ByVal session As String, ByRef items As Collection) As String
    Dim i As Integer, item As String
    createSBQuery = "s=" & session
    For i = 1 To items.Count
        item = item & "&a[" & i - 1 & "]=" & pe(items(i)(0)) '#artist name
        item = item & "&t[" & i - 1 & "]=" & pe(items(i)(1)) '#track title
        item = item & "&i[" & i - 1 & "]=" & items(i)(2) '#time the track started playing (UNIX UTC)
        item = item & "&o[" & i - 1 & "]=" & items(i)(3) '#source of track: P (chosen by user), R, E, L, U
        item = item & "&r[" & i - 1 & "]=" & items(i)(4) 'rating: 'L'ove, 'B'an, 'S'kip
        item = item & "&l[" & i - 1 & "]=" & items(i)(5) '#length of the track (note: req. if o=P)
        item = item & "&b[" & i - 1 & "]=" & pe(items(i)(6)) 'album title
        item = item & "&n[" & i - 1 & "]=" & items(i)(7) 'track number
        item = item & "&m[" & i - 1 & "]=" & items(i)(8) 'MusicBrainz Track ID
        createSBQuery = createSBQuery & item & IIf(i <> items.Count, "&", "")
        item = vbNullString
    Next i
End Function

Public Function setPrefs(ByVal user As String, ByVal md5pass As String, _
                    Optional client As String = DEFAULT_CLIENT, _
                    Optional clientV As String = DEFAULT_CLIENTVER, _
                    Optional hsURL As String = DEFAULT_HSURL, _
                    Optional hsUTC As Boolean = False) As Boolean
    If LenB(user) <> 0 And _
    checkMD5(md5pass) And _
    LenB(client) <> 0 And LenB(clientV) <> 0 And _
    checkRegExpMask(hsURL, REG_EXP_URL) Then
        setPrefs = True
        Status_hs = MUSTHANDSHAKE
    End If
    If LenB(user) <> 0 Then id.user = pe(user)
    If checkMD5(md5pass) Then id.md5pass = md5pass
    If LenB(client) <> 0 Then serv.client = client
    If LenB(clientV) <> 0 Then serv.clientV = clientV
    If checkRegExpMask(hsURL, REG_EXP_URL) Then serv.hsURL = hsURL
    serv.hsUTC = hsUTC
End Function

'SET TIMER AFTER INITIALIZATION OF CLASS
'U'LL GO TO HELL! U'LL GO TO HELL AND U'LL DIE, otherwise!
Public Function init(ByRef clk As Timer)
    If clock Is Nothing Then
        Set clock = clk
        clock.Interval = 1000 '    
        startTimer() = False
    End If
End Function

Public Sub sendHandShake()
    If Not isEnabled Then
qError "Last.FM: Will not handshake, because Last.FM is disabled."
        Exit Sub
    End If
    If Status_hs = CONNECTED Then
qError "Last.FM: Already connected to server."
        Exit Sub
    End If
    If Status_hs = HANDSHAKING Then http.Abort '   Handshake
    Status_hs = HANDSHAKING
qDebug "Last.FM: Sending handshake..."
    http.Open "GET", serv.hsURL & "/?" & createHSQuery(id.user, id.md5pass), True
'    http.SetRequestHeader "content-type", "application/x-www-form-urlencoded"
    http.Send
End Sub

Public Function sendNowPlaying(ByVal artist As String, ByVal song As String, _
                                Optional ByVal album As String, Optional ByVal secs As Long, _
                                Optional ByVal no As String, Optional ByVal mbid As String) As Boolean
    If Not isEnabled Then Exit Function
    If LenB(artist) = 0 Or LenB(song) = 0 Then Exit Function ' 
    
    If Status_hs = CONNECTED Then
        If Status_np = NPPOSTING Then http.Abort '   NowPlaying
        Status_np = NPPOSTING
con.WriteLine "Last.FM: Send Now-Playing: {0} - {1}", d_GENERAL, artist, song
        http.Open "POST", hs.nowPlayingURL, True
        http.SetRequestHeader "content-type", "application/x-www-form-urlencoded"
        http.Send createNPQuery(hs.sessionID, artist, song, album, secs, no, mbid)
        sendNowPlaying = True
    ElseIf Status_hs = MUSTHANDSHAKE Then
qError "Last.FM: Now-Playing failed, need handshake"
        sendHandShake '-  ,   
    End If
End Function

Private Sub Class_Terminate()
    putQueueToFile AppPath & QUEUE_CACHE_FILE
End Sub

Private Sub putQueueToFile(ByVal path As String)
    Dim i As Integer, j As Integer, hndl As Long
    Dim dat() As Byte, pos As Long
    pumpToQueue '      
                '..  
    hndl = io.openFile(path, CREATE_ALWAYS)
    If hndl <> INVALID_HANDLE_VALUE Then
        io.writeMagicToFile hndl, MAGIC_CH 'CH$
        For i = 1 To queue.Count
            ReDim dat(calcCacheItemLen(i) - 1)
            pos = 0
            For j = 0 To 8
                intToArr dat, LenB(queue(i)(j)), pos
                strToArr dat, CStr(queue(i)(j)), pos
            Next j
            io.writeBytesToFile hndl, dat
        Next i
        io.closeFile hndl
    End If
End Sub

'Calc len in bytes of an item in \queue\ (inc. 2 addit. bytes for each string to store it's len)
Private Function calcCacheItemLen(ByVal item As Integer) As Integer
    Dim i As Integer
    If item > queue.Count Then Exit Function
    For i = 0 To 8
        calcCacheItemLen = calcCacheItemLen + 2 + LenB(queue(item)(i))
    Next i
End Function

Private Sub clock_Timer()
    If Not isEnabled Then   ' 
        startTimer = False
        Exit Sub
    End If
    If iterate(clk_tick, clk_int) <> clk_int Then Exit Sub
    If clk_int < 32 * 60 Then clk_int = clk_int * 2 '       
qDebug "Last.FM: Timer now (Timer will handshake - should be next)"
    If Status_hs = WILLHANDSHAKE Then
qDebug "Last.FM: Timer will handshake."
        sendHandShake
    End If
End Sub

Private Property Let startTimer(Optional ByVal intv As Integer = 60, ByVal start As Boolean)
con.WriteLine "Last.FM: Timer({1})={0}", d_GENERAL, start, intv
    clk_int = intv '  
    clk_tick = 0 ' 
    clock.Enabled = start
End Property

Private Sub http_OnError(ByVal ErrorNumber As Long, ByVal ErrorDescription As String)
qDebug "Last.FM: HARD FAILURE (HTTP OnError)"
' HARD FAILURE
    Call msgError("_OnError " & ErrorNumber & " " & ErrorDescription)
    If Status_hs = HANDSHAKING Then
        Status_hs = WILLHANDSHAKE
        Call msgError("Hard failure.")
        startTimer(clk_int) = True
    End If
End Sub

Private Sub http_OnResponseFinished()
    Dim dat() As String, str As String
    str = http.ResponseText
    If Right$(str, 1) = vbLf Then str = Left$(str, Len(str) - 1)
    dat = Split(str, vbLf)
    If Status_hs = HANDSHAKING Then
        If dat(0) = "OK" Then
qDebug "Last.FM: Handshake got OK, now parsing"
            If UUBound(dat) <> 3 Then
qError "Last.FM: Response is unparsable. Turn off."
                Status_hs = CANNOTCONNECT
                Call msgError("Critical! Got unparsable response: " & str)
            Else
qDebug "Last.FM: Handshaked."
                Status_hs = CONNECTED
                RaiseEvent response("Success: OK (handshaked)")
                hs.sessionID = dat(1)
                hs.nowPlayingURL = dat(2)
                hs.scrobblingURL = dat(3)
                startTimer() = False
                If queue.Count > 0 Then submit ',   
            End If
        ElseIf dat(0) = "BANNED" Then
qError "Last.FM: We are banned, try another client\version"
            Status_hs = CANNOTCONNECT
            Call msgError("Critical! This software is BANNED.")
        ElseIf dat(0) = "BADAUTH" Then
qError "Last.FM: Cannot connect because of bad login\password"
            Status_hs = CANNOTCONNECT
            Call msgError("Critical! Wrong user login\password!")
        ElseIf dat(0) = "BADTIME" Then
qError "Last.FM: Cannot connect because of bad time stamp"
            Status_hs = CANNOTCONNECT
            Call msgError("Critical! Bad time stamp!")
        Else
qError "Last.FM: Some hard failure on handshake"
            Status_hs = WILLHANDSHAKE
            Call msgError("Hard failure.")
            startTimer(clk_int) = True
        End If
    ElseIf Status_hs = CONNECTED And Status_np = NPPOSTING Then
        If dat(0) = "OK" Then
qDebug "Last.FM: Now-Playing sent successfully"
            Status_np = NP_NOACTION
            RaiseEvent response("Success.")
        ElseIf dat(0) = "BADSESSION" Then
qError "Last.FM: Now-Playing failed because of bad session"
            Status_np = NP_NOACTION
            Status_hs = MUSTHANDSHAKE
            Call msgError("Got BADSESSION, re-handshaking..")
            sendHandShake
        End If
    End If
End Sub

'     
Public Sub scrobble(ByVal artist As String, ByVal song As String, _
                        ByVal started As Long, ByVal length As Long, Optional ByVal album As String, _
                        Optional ByVal Source As String = "P", Optional ByVal rating As String, _
                        Optional ByVal no As String, Optional ByVal mbid As String)
    If Not isEnabled Then Exit Sub
    
    '    30      
    '  ,        
    If length < 30 Or (UNIXTimeUTC - started) < (length / 2) Or _
    LenB(artist) = 0 Or LenB(song) = 0 Then Exit Sub

    Dim dat(0 To 8) As String
    dat(0) = artist '#artist name
    dat(1) = song '#track title
    dat(2) = CStr(started) '#time the track started playing (UNIX UTC)
    dat(3) = Source '#source of track: P (chosen by user), R, E, L, U
    dat(4) = rating 'rating: 'L'ove, 'B'an, 'S'kip
    dat(5) = CStr(length) '#length of the track (note: req. if o=P)
    dat(6) = album 'album title
    dat(7) = no 'track number
    dat(8) = mbid 'MusicBrainz Track ID

qDebug "Last.FM: Start scrobbling"
    If Status_sb >= SCROBBLING And Status_sb <= SCROBBLING + 2 Then
qError "Last.FM: Another scrobbling's in progress, will submit next time"
        If queueToQueue.Count = 50 Then queueToQueue.Remove (1)
        queueToQueue.Add dat
    Else
qDebug "Last.FM: Trying to scrobble..."
        If queue.Count = 50 Then queue.Remove (1)
        queue.Add dat
        submit
    End If
End Sub

Private Sub submit()
    If queue.Count = 0 Then
qError "Last.FM: Err: Nothing to submit. Queue is empty."
        Exit Sub
    End If
    If Status_hs = CONNECTED Then
        Status_sb = Status_sb + 1
        If Status_sb > SCROBBLING + 2 Then '     
qError "Last.FM: 3 scrobblings failed, handshaking"
            Status_sb = SB_NOACTION
            Status_hs = MUSTHANDSHAKE
            sendHandShake
            Exit Sub
        End If
qDebug "Last.FM: Scrobbling..."
        httpSb.Open "POST", hs.scrobblingURL, True
        httpSb.SetRequestHeader "content-type", "application/x-www-form-urlencoded"
        httpSb.Send createSBQuery(hs.sessionID, queue)
    ElseIf Status_hs = MUSTHANDSHAKE Then
qError "Last.FM: will scrobble next time, need handshake"
        sendHandShake
    Else
qError "Last.FM: will scrobble next time, no connection"
    End If
End Sub

Private Sub pumpToQueue()
    Dim i As Integer
    For i = 1 To queueToQueue.Count
        If queue.Count = 50 Then queue.Remove (1)
        queue.Add queueToQueue(i)
    Next i
    Set queueToQueue = New Collection
End Sub

Private Sub httpSb_OnError(ByVal ErrorNumber As Long, ByVal ErrorDescription As String)
    Call msgError("Hard failure on submission. (httpSb_OnError)")
    submit
End Sub

Private Sub httpSb_OnResponseFinished()
    Dim dat() As String, str As String
    str = httpSb.ResponseText
    If Right$(str, 1) = vbLf Then str = Left$(str, Len(str) - 1)
    dat = Split(str, vbLf)
    
    If dat(0) = "OK" Then
qDebug "Last.FM: Scrobbled successfully"
        Set queue = New Collection ' ,  
        Call pumpToQueue ' 
        Status_sb = SB_NOACTION
        RaiseEvent response("Success.")
        If queue.Count > 0 Then submit '  pumpToQueue  queue  , 
    ElseIf dat(0) = "BADSESSION" Then
qError "Last.FM: Scrobbling failed because of bad session"
        Call pumpToQueue ' 
        Status_sb = SB_NOACTION
        Status_hs = MUSTHANDSHAKE
        Call msgError("Got BADSESSION, re-handshaking..")
        sendHandShake
    Else
qError "Last.FM: Hard failure on scrobbling"
        Call msgError("Hard failure on submission.")
        Call pumpToQueue ' 
        'Status_sb   submit
        submit
    End If
End Sub

'-----------------------------------------------------------------------------------------------------------
'------------------------------SERVICE-FUNCTIONS------------------------------------------------------------
'-----------------------------------------------------------------------------------------------------------

Public Function UNIXTimeUTC() As Long
    Dim q As SYSTEMTIME
    GetSystemTime q
    UNIXTimeUTC = DateDiff("s", "1970-01-01", q.wDay & "/" & q.wMonth & "/" & q.wYear & " " & q.wHour & ":" & q.wMinute & ":" & q.wSecond)
'    Debug.Print q.wMonth & "/" & q.wDay & "/" & q.wYear & " " & q.wHour & ":" & q.wMinute & ":" & q.wSecond, UNIXTimeUTC
End Function

Public Function UNIXTime() As Long
    UNIXTime = DateDiff("s", "1970-01-01", Now)
'    Debug.Print Month(Now) & "/" & Day(Now) & "/" & year(Now) & " " & Hour(Now) & ":" & Minute(Now) & ":" & Second(Now), UNIXTime
End Function

Private Function UUBound(arr) As Long
On Error GoTo 1:
    UUBound = UBound(arr)
Exit Function
1:  UUBound = -1
End Function

Private Sub Class_Initialize()
    Set http = New WinHttpRequest
    Set httpSb = New WinHttpRequest
    Call initPercentMap
    Status_hs = CANNOTCONNECT 'Cannot connect before prefs are set

    readQueueFromFile AppPath & QUEUE_CACHE_FILE
End Sub

Private Sub readQueueFromFile(ByVal path As String)
    Dim arr() As Byte, ub As Long
    Dim intg As Integer, pos As Long, dat(0 To 8) As String
    arr = io.ReadBytesFromFile(path)
    ub = UUBound(arr)
    If (ub + 1) < Len(MAGIC_CH) Then Exit Sub
    If Not checkMagicRecord(arr, MAGIC_CH, pos) Then Exit Sub
    While pos < ub
      If pos + 1 > ub Then Exit Sub
      intg = byteToInt(arr, pos)
      If pos + intg - 1 > ub Then Exit Sub
      dat(0) = midFromArr(arr, pos, intg) '#artist name (percent-encoded)
        If pos + 1 > ub Then Exit Sub
        intg = byteToInt(arr, pos)
        If pos + intg - 1 > ub Then Exit Sub
        dat(1) = midFromArr(arr, pos, intg) '#track title (percent-encoded)
      If pos + 1 > ub Then Exit Sub
      intg = byteToInt(arr, pos)
      If pos + intg - 1 > ub Then Exit Sub
      dat(2) = midFromArr(arr, pos, intg) '#time the track started playing (UNIX UTC)
        If pos + 1 > ub Then Exit Sub
        intg = byteToInt(arr, pos)
        If pos + intg - 1 > ub Then Exit Sub
        dat(3) = midFromArr(arr, pos, intg) '#source of track: P (chosen by user), R, E, L, U
      If pos + 1 > ub Then Exit Sub
      intg = byteToInt(arr, pos)
      If pos + intg - 1 > ub Then Exit Sub
      dat(4) = midFromArr(arr, pos, intg) 'rating: 'L'ove, 'B'an, 'S'kip
        If pos + 1 > ub Then Exit Sub
        intg = byteToInt(arr, pos)
        If pos + intg - 1 > ub Then Exit Sub
        dat(5) = midFromArr(arr, pos, intg) '#length of the track (note: req. if o=P)
      If pos + 1 > ub Then Exit Sub
      intg = byteToInt(arr, pos)
      If pos + intg - 1 > ub Then Exit Sub
      dat(6) = midFromArr(arr, pos, intg) 'album title (percent-encoded)
        If pos + 1 > ub Then Exit Sub
        intg = byteToInt(arr, pos)
        If pos + intg - 1 > ub Then Exit Sub
        dat(7) = midFromArr(arr, pos, intg) 'track number
      If pos + 1 > ub Then Exit Sub
      intg = byteToInt(arr, pos)
      If pos + intg - 1 > ub Then Exit Sub
      dat(8) = midFromArr(arr, pos, intg) 'MusicBrainz Track ID
        queue.Add dat
    Wend
End Sub

Private Function toUTF8(ByVal str As String) As String
    Dim ConvString As String, BufLen As Long, StrBuffer() As Byte
    BufLen = WideCharToMultiByte(CP_UTF8, 0&, ByVal StrPtr(str), _
                Len(str), ByVal 0&, 0&, ByVal 0&, ByVal 0&)
    If (BufLen) Then
        ReDim StrBuffer(0 To BufLen - 1) As Byte
        Call WideCharToMultiByte(CP_UTF8, 0&, ByVal StrPtr(str), _
                Len(str), StrBuffer(0), BufLen, ByVal 0&, ByVal 0&)
        toUTF8 = StrConv(StrBuffer(), vbUnicode)
    End If
End Function

Private Sub initPercentMap()
    Dim unreserved_symbols As String, i As Integer
    '  .
    '    URL
    unreserved_symbols = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_.~"
    For i = 1 To Len(unreserved_symbols)
        percentMap(AscW(Mid$(unreserved_symbols, i, 1))) = Mid$(unreserved_symbols, i, 1)
    Next i
    '  : !*'():@&=+$,/?%#[]  
    '       URI.
    '                
'    reserved_symbols_allowed = vbNullString
'    For i = 1 To Len(reserved_symbols_allowed)
'        ascii_map(Asc(Mid$(reserved_symbols_allowed, i, 1))) = Mid$(reserved_symbols_allowed, i, 1)
'    Next i
    '   
    For i = 0 To 255
        If i < 16 Then
            percentMap(i) = "%0" & Hex$(i)
        Else
            If Len(percentMap(i)) = 0 Then percentMap(i) = "%" & Hex$(i)
        End If
    Next i
End Sub

'Percent-encode string
Private Function pe(ByVal str As String) As String
    Dim i As Long, utfstr As String
    utfstr = toUTF8(str)
    For i = 1 To Len(utfstr)
        pe = pe & _
            percentMap(Asc(Mid$(utfstr, i, 1)))
    Next i
End Function

'RV: \true\ if \str\ consists of 32 symbols (0-9, a-f)
Private Function checkMD5(ByVal str As String) As Boolean
    Dim i As Long, ch As Integer
    If Len(str) <> 32 Then Exit Function
    For i = 1 To Len(str)
        ch = AscW(Mid$(str, i, 1))
        If Not ((ch >= 48 And ch <= 57) Or (ch >= 97 And ch <= 102)) Then Exit Function
    Next i
    checkMD5 = True
End Function

Private Sub msgError(ByRef str As String)
    RaiseEvent error(str, 0)
End Sub

' 
'0 -> 1 -> ... -> max -> 1 -> ...
Public Function iterate(ByRef var As Integer, ByRef max As Integer) As Integer
    If var >= max Then var = 1 _
    Else var = var + 1
    iterate = var
End Function

'RV: user-name (percent-encoded if not latin)
Public Property Get user() As String
    user = id.user
End Property

Public Property Get md5pass() As String
    md5pass = id.md5pass
End Property

Public Property Get hsURL() As String
    hsURL = serv.hsURL
End Property

Public Property Get hsUTC() As Boolean
    hsUTC = serv.hsUTC
End Property

Public Property Get client() As String
    client = serv.client
End Property

Public Property Get clientV() As String
    clientV = serv.clientV
End Property

Public Property Get def_hsURL() As String
    def_hsURL = DEFAULT_HSURL
End Property

Public Property Get def_client() As String
    def_client = DEFAULT_CLIENT
End Property

Public Property Get def_clientV() As String
    def_clientV = DEFAULT_CLIENTVER
End Property

Public Property Let disable(ByVal bool As Boolean)
    disabled = bool
End Property

' ,    - \false\
Public Property Get isEnabled() As Boolean
    If Status_hs <> CANNOTCONNECT And Not disabled And _
    checkRegExpMask(serv.hsURL, REG_EXP_URL) And _
    LenB(serv.client) <> 0 And LenB(serv.clientV) <> 0 And _
    LenB(id.md5pass) <> 0 And LenB(id.user) <> 0 Then isEnabled = True
End Property

Public Property Get isOnline() As Boolean
    ' ,     
    isOnline = (Status_hs = CONNECTED) And Not disabled
End Property
