Attribute VB_Name = "mod"
'    Copyright 2009, 2010 Makarov Andrey
'
'    This file is part of Audica - Open Simple Audio Player.
'
'    Audica is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    Audica is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with Audica.  If not, see <http://www.gnu.org/licenses/>.

Option Explicit
Private Declare Sub PathStripPath Lib "shlwapi.dll" Alias "PathStripPathW" (ByVal pszPath As Long)
Private Declare Sub PathRemoveExtension Lib "shlwapi.dll" Alias "PathRemoveExtensionW" (ByVal pszPath As Long)
Private Declare Function PathRemoveFileSpec Lib "shlwapi.dll" Alias "PathRemoveFileSpecW" (ByVal pszPath As Long) As Long
Private Declare Function PathFindExtension Lib "shlwapi.dll" Alias "PathFindExtensionW" (ByVal pszPath As Long) As Long
Private Declare Function GetCommandLine Lib "kernel32.dll" Alias "GetCommandLineW" () As Long
Private Declare Function LoadLibrary Lib "kernel32.dll" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Private Declare Function FreeLibrary Lib "kernel32.dll" (ByVal hLibModule As Long) As Long
Private libbass As Long, libtags As Long, libfreeimage As Long

Private Declare Function OleTranslateColor Lib "oleaut32" (ByVal clr As OLE_COLOR, ByVal hPal As Long, dwRGB As Long) As Long

Public Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Public Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpString As Any, ByVal lpFileName As String) As Long

Public Declare Sub ZeroMemory Lib "kernel32.dll" Alias "RtlZeroMemory" (ByRef Destination As Any, ByVal length As Long)
Public Declare Function SelectObject Lib "GDI32" (ByVal hdc&, ByVal hObject&) As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (lpDest As Any, lpSource As Any, ByVal cBytes&)
Public udtNMLVCUSTOMDRAW As NMLVCUSTOMDRAW
Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type
Public Type NMHDR
    hWndFrom As Long   ' Window handle of control sending message
    idFrom As Long        ' Identifier of control sending message
    code  As Long          ' Specifies the notification code
End Type
Public Type NMCUSTOMDRAW
    hdr As NMHDR
    dwDrawStage As Long
    hdc As Long
    rc As RECT
    it As Long 'dwItemSpec
    uItemState As Long
    lItemlParam As Long
End Type
Public Type NMLVCUSTOMDRAW ' listview specific customdraw struct
    nmcd As NMCUSTOMDRAW
    clrText As Long
    clrTextBk As Long
    iSubItem As Integer ' if IE >= 4.0 this member of the struct can be used
End Type
Public Const CDDS_ITEM As Long = &H10000
Public Const CDDS_PREPAINT As Long = &H1
Public Const CDDS_ITEMPREPAINT As Long = (CDDS_ITEM Or CDDS_PREPAINT)
    Public Const CDDS_POSTPAINT As Long = &H2
    Public Const CDDS_ITEMPOSTPAINT As Long = (CDDS_ITEM Or CDDS_POSTPAINT)
Public Const CDRF_NOTIFYITEMDRAW As Long = &H20
Public Const CDRF_NOTIFYSUBITEMDRAW As Long = &H20&
Public Const CDDS_SUBITEM  As Long = &H20000
Public Const CDRF_NEWFONT As Long = &H2&
    Public Const CDRF_SKIPPOSTPAINT = 256
    Public Const CDRF_NOTIFYPOSTPAINT As Long = &H10
    Public Const CDRF_SKIPDEFAULT As Long = &H4
    Public Const CDRF_DODEFAULT As Long = &H0

Const playlistFormats As String = "*.m3u;*.m3u8;*.pls"
Const builtInFormats As String = "*.mp3;*.mp2;*.mp1;*.ogg;*.wav;*.aif"
Public Plugin_list As String '  ( About)
Public fFilter As String '    
Public rxFilter As String 'fFilter   - mp3|ogg|...
Public audicaLoaded As Boolean '   
Public FreeImageAvailable As Boolean 'true -   FreeImage
Public UploadToolAvailable As Boolean 'true -    
Public newInternetStreamTags As Boolean '   ,   MetaSync
Public Const CCLEAR_INTERNET_TAGS As Byte = 1
Public MiniMode As Boolean  '  

'Private optXMLNode As IXMLDOMNode

'Convert VB system color to RGB
Public Function cColor(ByVal clr As Long, Optional hPal As Long = 0) As Long
    If bits(vbButtonFace, &H80000000) Then
        If OleTranslateColor(clr, hPal, cColor) Then cColor = &HFFFF
    Else
        cColor = clr
    End If
End Function

Public Function IniStringPrivate(SekName As String, KeyName As String, DefaultVal As Variant, Optional IniFileName As String) As String
    Dim sTemp As String * 556, nTemp As Integer
    nTemp = GetPrivateProfileString(SekName, KeyName, DefaultVal, sTemp, 555, IIf(LenB(IniFileName) = 0, AppPath & "options.ini", IniFileName))
    IniStringPrivate = Left$(sTemp, nTemp)
End Function
Public Function IniWriteStrPrivate(SekName As String, KeyName As String, param As String, Optional IniFileName As String) As Long
    Dim nTemp As Long
    If LenB(param) <> 0 Then
        nTemp = WritePrivateProfileString(SekName, KeyName, param, IIf(LenB(IniFileName) = 0, AppPath & "options.ini", IniFileName))
        IniWriteStrPrivate = 1
    Else
        IniWriteStrPrivate = 0
    End If
End Function
Public Function IniReadVal(ByVal SekName As String, ByVal KeyName As String, ByVal DefaultVal As Long, ByVal vMin As Long, ByVal vMax As Long, Optional ByVal IniFileName As String) As Long
    Dim sTemp As String * 11, nTemp As Integer
    nTemp = GetPrivateProfileString(SekName, KeyName, DefaultVal, sTemp, Len(sTemp), IIf(LenB(IniFileName) = 0, AppPath & "options.ini", IniFileName))
    IniReadVal = val(Left$(sTemp, nTemp))
    If IniReadVal < vMin Or IniReadVal > vMax Then IniReadVal = DefaultVal 'Out of range. Return default value.
End Function
Public Function IniWriteVal(SekName As String, KeyName As String, ByVal param As Long, ByVal DefaultVal As Long, ByVal vMin As Long, ByVal vMax As Long, Optional IniFileName As String) As Long
    If param < vMin Or param > vMax Then param = DefaultVal
    IniWriteVal = WritePrivateProfileString(SekName, KeyName, CStr(param), IIf(LenB(IniFileName) = 0, AppPath & "options.ini", IniFileName))
End Function
Public Function IniWriteBool(SekName As String, KeyName As String, ByVal param As Boolean, Optional IniFileName As String) As Long
    IniWriteBool = WritePrivateProfileString(SekName, KeyName, CStr(CByte(param)), IIf(LenB(IniFileName) = 0, AppPath & "options.ini", IniFileName))
End Function
Public Function IniReadBool(SekName As String, KeyName As String, ByVal DefaultVal As Boolean, Optional IniFileName As String) As Boolean
    Dim sTemp As String * 3, nTemp As Integer
    nTemp = GetPrivateProfileString(SekName, KeyName, IIf(DefaultVal, 255, 0), sTemp, Len(sTemp), IIf(LenB(IniFileName) = 0, AppPath & "options.ini", IniFileName))
    IniReadBool = CBool(val(Left$(sTemp, nTemp)))
End Function
Public Function IniDelAllKeyPrivate(SekName As String, Optional IniFileName As String) As Long
    IniDelAllKeyPrivate = WritePrivateProfileString(SekName, vbNullString, vbNullString, IIf(LenB(IniFileName) = 0, AppPath & "options.ini", IniFileName))
End Function

'----------------------------
Public Function writeGenOptionLng(KeyName As String, ByVal param As Long, ByVal DefaultVal As Long, ByVal vMin As Long, ByVal vMax As Long) As Long
    writeGenOptionLng = IniWriteVal("General", KeyName, param, DefaultVal, vMin, vMax)
End Function

'''Public Function writeGenOptionStr(KeyName As String, param As String) As Long
'''    writeGenOptionLng = IniWriteStrPrivate("General", KeyName, param)
'''End Function
'----------------------------

Public Function AppPath() As String
    If Right$(App.path, 1) <> "\" Then AppPath = App.path & "\" Else AppPath = App.path
End Function

Public Sub wOptions()
    writeGenOptionLng "SpecMode", specmode, 0, 0, SPECTRUM_UBOUND
    writeGenOptionLng "Volume", BASS_GetConfig(BASS_CONFIG_GVOL_STREAM), 10000, 0, 10000
    IniWriteBool "General", "Continue", Form1.mnu_playOnStart.Checked
    IniWriteBool "General", "Lights", Form1.mnu_blink_leds.Checked
    IniWriteBool "General", "WDMColor", Form1.mnu_blink_windows.Checked
'Window Position
    writeGenOptionLng "WindowState", Form1.WindowState, vbNormal, vbNormal, vbMaximized
    If Form1.WindowState = vbNormal Then
        writeGenOptionLng "WindowLeft", Form1.Left, 0, 0, Screen.Width
        writeGenOptionLng "WindowTop", Form1.Top, 0, 0, Screen.Height
        writeGenOptionLng "WindowHeight", Form1.Height, 5580, 5580, Screen.Height
        writeGenOptionLng "WindowWidth", Form1.Width, 5550, 3735, Screen.Width
    End If
'Last.fm
    IniWriteStrPrivate "Last.fm", "user", Form1.lFM.user
    IniWriteStrPrivate "Last.fm", "md5pass", Form1.lFM.md5pass
    IniWriteStrPrivate "Last.fm", "client", Form1.lFM.client
    IniWriteStrPrivate "Last.fm", "clientVer", Form1.lFM.clientV
    IniWriteStrPrivate "Last.fm", "handshake", Form1.lFM.hsURL
    IniWriteBool "Last.fm", "isEnabled", Form1.lFM.isEnabled
    IniWriteBool "Last.fm", "hsUTCTime", Form1.lFM.hsUTC
End Sub

Public Sub rOptions()
    Call BASS_SetConfig(BASS_CONFIG_NET_PLAYLIST, 1) ' enable playlist processing for i-net streams

    Form1.Progress.enable = False
    Form1.sld_vol.max = 10000
    Form1.sld_vol.position = IniReadVal("General", "Volume", 10000, 0, 10000)
    specmode = IniReadVal("General", "SpecMode", 0, 0, SPECTRUM_UBOUND)
    Form1.mnu_playOnStart.Checked = IniReadBool("General", "Continue", False)
    Form1.mnu_blink_leds.Checked = IniReadBool("General", "Lights", True)
    Form1.mnu_blink_windows.Checked = IniReadBool("General", "WDMColor", False)

'Window Position
    Form1.WindowState = IniReadVal("General", "WindowState", 0, 0, 2)
    If Form1.WindowState = 0 Then 'WindowState - Normal
        Form1.Left = IniReadVal("General", "WindowLeft", 0, 0, Screen.Width)
        Form1.Top = IniReadVal("General", "WindowTop", 0, 0, Screen.Height)
        Form1.Height = IniReadVal("General", "WindowHeight", 5580, 5580, Screen.Height)
        Form1.Width = IniReadVal("General", "WindowWidth", 5550, 3735, Screen.Width)
    End If
'Last.fm
    Dim str(5) As String, isEnabled As Boolean, hsUTC As Boolean
    str(0) = IniStringPrivate("Last.fm", "user", "")
    str(1) = IniStringPrivate("Last.fm", "md5pass", "")
    str(2) = IniStringPrivate("Last.fm", "client", Form1.lFM.def_client)
    str(3) = IniStringPrivate("Last.fm", "clientVer", Form1.lFM.def_clientV)
    str(4) = IniStringPrivate("Last.fm", "handshake", Form1.lFM.def_hsURL)
    isEnabled = IniReadBool("Last.fm", "isEnabled", False)
    hsUTC = IniReadBool("Last.fm", "hsUTCTime", False)
    Form1.lFM.setPrefs str(0), str(1), str(2), str(3), str(4), hsUTC
    Form1.lFM.disable = Not isEnabled
    Form1.mnu_last_fm.Checked = Form1.lFM.isEnabled
End Sub

Public Function UUBound(arr) As Long
On Error GoTo 1:
    UUBound = UBound(arr)
Exit Function
1:  UUBound = -1
End Function

'    
Public Function PathFilename(ByRef pth As String, Optional withExt As Boolean) As String
    Dim p As Long
    PathFilename = pth
    PathStripPath StrPtr(PathFilename)
    If Not withExt Then PathRemoveExtension StrPtr(PathFilename)
    If b(p, InStr(1, PathFilename, vbNullChar)) Then _
        PathFilename = Left$(PathFilename, p - 1)
End Function

'    
Public Function PathFolder(ByRef pth As String) As String
    Dim p As Long
    PathFolder = pth
    PathRemoveFileSpec StrPtr(PathFolder)
    If b(p, InStr(1, PathFolder, vbNullChar)) Then _
        PathFolder = Left$(PathFolder, p - 1)
End Function

'  
Public Function PathExt(ByRef pth As String) As String
    Dim p As Long
    If b(p, InStrRev(pth, ".")) Then _
        If InStrRev(pth, "\") < p Then PathExt = Mid$(pth, p + 1)
End Function

Public Function MinSec(ByVal sec As Single) As String
    MinSec = sec \ 60 & ":" & Format$(sec Mod 60, "00")
End Function

Public Function HourMinSec(ByVal sec As Double) As String
    Dim H As Long
    If b(H, sec \ 3600) Then
        HourMinSec = H & ":" & Format$(sec \ 60 - H * 60, "00") & ":" & Format$(sec Mod 60, "00")
    Else
        HourMinSec = sec \ 60 & ":" & Format$(sec Mod 60, "00")
    End If
End Function

Rem/////////////////////////
Sub Main()
    Randomize
    If Not int_isClient Then
        If Not initBass Then '  init 
            int_destroyServer_ifNotClient
            End
        End If
        Call OleInitialize(ByVal 0&) 'COM
        Call Load(con) ' -
        Call InitPlugins '  (  )
        Call LoadColors(IniStringPrivate("General", "Colors", ""))
        Call Load(Form1) '  
        Call ApplyColors
        Call rOptions    '   INI,    
        If Form1.lFM.isEnabled Then _
            Form1.lFM.sendHandShake 'Start Last.fm
        Call InitSpectrum(Form1.box_spectr.Width, cColor(Form1.box_spectr.BackColor)) ' 
        If Not WDMIsReady Then
            Form1.mnu_blink_windows.Visible = False
        ElseIf Form1.mnu_blink_windows.Checked Then
            Call InitWDM
        End If
        If Form1.mnu_blink_leds.Checked Then _
            Call OpenKeyboardDevice 'LED
        If LenB(Dir$("hooktool.exe")) <> 0 Then Shell "hooktool.exe"
        Call Form1.show '  
        Call Form1.Refresh
        Call Form1.TaskbarAddButtons
        If Not LoadFromCommand(CommandLine$) Then '   Command$
            If Form1.mnu_playOnStart.Checked Then _
                Form1.tabs.active.resumePlaying
        End If
        audicaLoaded = True
        Call int_procBuffer
    Else ' ,       
        If LenB(CommandLine$) <> 0 Then _
            int_sendData CommandLine$, App.hInstance
        End
    End If
End Sub

Sub Destroy()
    Dim frm As Object
    ' "free" the output device and all plugins
    Call BASS_Free
    Call BASS_PluginFree(0)
    
    If libbass Then FreeLibrary libbass
    If libtags Then FreeLibrary libtags
    If FreeImageAvailable Then FreeLibrary libfreeimage
    
    CloseKeyboardDevice
    int_destroyServer_ifNotClient
    int_unhook
    
    For Each frm In Forms
        Unload frm
    Next frm
    
    Call OleUninitialize 'COM
End Sub
Rem/////////////////////////

Public Function LoadFromCommand(ByVal cmd As String) As Boolean
    Dim lst As frm_plst
    If LenB(cmd) <> 0 Then '  
        cmd = IIf(Left$(cmd, 1) = """" And Right$(cmd, 1) = """", Mid$(cmd, 2, Len(cmd) - 2), cmd)
        If Form1.tabs.default <> Form1.tabs.NO_DEFAULT Then
            Call Form1.tabs.Activate(Form1.tabs.default)
        Else
            Call Form1.tabs.Create
            Form1.tabs.default = Form1.tabs.activeID
        End If
        Set lst = Form1.tabs.active
        Form1.chk_rnd.value = (lst.chooseMethod = RANDOM)
        Form1.chk_def.value = True
        Call lst.populationStart
        Call lst.slotAddStream(cmd, checkRegExpMask(cmd, REG_EXP_URL))
        Call lst.populationFinish
        Call Form1.tabs.draw
        lst.slotPlayItem lst.hBound
        LoadFromCommand = True
    End If
End Function

'Get first argument of command line
Private Function CommandLine() As String
    If inIDE Then CommandLine = Command$: Exit Function
    
    Dim buffer(511) As Byte, pointer As Long, p1 As Long, p2 As Long
    pointer = GetCommandLine()
    CopyMemory buffer(0), ByVal pointer, 512
    CommandLine = CStr(buffer)
    p1 = InStrB(1, CommandLine, """ """)
    If p1 Then
        p1 = p1 + 6
        p2 = InStrB(p1, CommandLine, """")
        If p2 > p1 Then _
            CommandLine = MidB$(CommandLine, p1, p2 - p1)
    End If
    If p1 = 0 Or p2 = 0 Then CommandLine = vbNullString ' 
End Function

Private Function initBass() As Boolean
    ' change and set the current path, to prevent from VB not finding BASS.DLL
    ChDrive App.path
    ChDir App.path
    If b(libbass, LoadLibrary("bass.dll")) Then
        ' check the correct BASS was loaded
        If (HiWord(BASS_GetVersion) <> BASSVERSION) Then
            Call MsgBox("An incorrect version of BASS.DLL was loaded", vbCritical)
            Exit Function
        End If
        ' initialize default output device
        If (BASS_Init(-1, 44100, 0, frm_info.hwnd, 0) = 0) Then
            Call Error_("Can't initialize device")
            Exit Function
        End If
        ' check that DX8 features are available
        Dim bi As BASS_INFO
        Call BASS_GetInfo(bi)
        If (bi.dsver < 8) Then
            Call Error_("DirectX 8 is not installed")
            Call BASS_Free
            Exit Function
        End If
        ' load tag-reading library
        If Not b(libtags, LoadLibrary("tags.dll")) Then
            Call MsgBox("Can't load tags.dll", vbCritical)
            Call BASS_Free
            Exit Function
        End If
        initBass = True
    Else
        Call MsgBox("Can't load BASS library", vbCritical)
    End If
End Function

' 
'        (fFilter)
Private Sub InitPlugins()
    Dim Filter As String, AllSupp As String
    Dim pinfo As BASS_PLUGININFO, plug As Long, Filename As String
    Dim info As BASS_PLUGINFORM
    Dim a As Long, i As Integer
    
    Filter = "Playlists (" & playlistFormats & ")|" & playlistFormats & "|" & _
             "BASS built-in (" & builtInFormats & ")|" & builtInFormats
    AllSupp = builtInFormats

    'look for plugins (in the executable's directory)
    io.enumFiles App.path, ".*\.plug\.dll"
    For i = 1 To io.filesResult.Count
        If b(plug, BASS_PluginLoad(io.filesResult(i), 0)) Then ' plugin loaded...
            Filename = PathFilename(io.filesResult(i))
            pinfo = BASS_PluginGetInfo(plug) ' get plugin info to add to the file selector filter...
            For a = 0 To pinfo.formatc - 1
                info = BASS_PluginGetInfoFormat(plug, a)
                Plugin_list = Plugin_list & VBStrFromAnsiPtr(info.name) & vbNewLine
                Filter = Filter & "|" & VBStrFromAnsiPtr(info.name) & " (" & VBStrFromAnsiPtr(info.exts) & ")" & " - " & Filename ' format description
                Filter = Filter & "|" & VBStrFromAnsiPtr(info.exts)  ' extension filter
                AllSupp = AllSupp & ";" & VBStrFromAnsiPtr(info.exts)
            Next a
        End If
    Next i
    
    rxFilter = Replace$(AllSupp, ";*.", "|")
    rxFilter = Right$(rxFilter, Len(rxFilter) - 2)
    fFilter = "All Supported|" & AllSupp & "|" & _
              Filter & "|" & _
             "All files|*.*"

'FreeImage----------------
    io.enumFiles App.path, "FreeImage\.dll"
    If io.filesResult.Count > 0 Then _
        FreeImageAvailable = b(libfreeimage, LoadLibrary(AppPath & "FreeImage.dll"))
    If FreeImageAvailable Then
        qDebug "FreeImage library is available"
        Plugin_list = Plugin_list & "FreeImage library"
    End If
'Upload Tool-------------
    If LenB(Dir$("upload.exe")) <> 0 Then _
        UploadToolAvailable = True
End Sub

' display error messages
Sub Error_(ByVal mes As String)
    Call MsgBox(mes & vbCrLf & vbCrLf & "(error code: " & BASS_ErrorGetCode & ")", vbExclamation, "Error!")
End Sub

'Public Function createXMLDoc() As IXMLDOMNode
'    Dim doc As New DOMDocument
'    Set createXMLDoc = doc.createElement("data") ' Create the Values section node.
'    doc.appendChild createXMLDoc ' Add the Values section node to the document.
'End Function
'
'Public Sub saveXMLDoc(ByRef node As IXMLDOMNode, ByVal Path As String)
'    node.ownerDocument.save Path
'End Sub
'
'Public Function loadXMLDoc(ByVal Path As String) As IXMLDOMNode
'    Dim doc As DOMDocument
'    Set doc = New DOMDocument
'    If Not doc.Load(Path) Then Exit Function
'    If doc.documentElement Is Nothing Then Exit Function
'    Set loadXMLDoc = doc.selectSingleNode(".//data")
'End Function

Public Sub SUBDOWNLOADPROC(ByVal buffer As Long, ByVal length As Long, ByVal user As Long)
    If (buffer And length = 0) Then
        qDebug VBStrFromAnsiPtr(buffer) ' display connection status
    End If
End Sub

Public Sub MetaSync(ByVal Handle As Long, ByVal channel As Long, ByVal data As Long, ByVal user As Long)
    Static staticmeta As String
    Dim meta As String
    If user = CCLEAR_INTERNET_TAGS Then staticmeta = vbNullString
    meta = getRadioTitle(channel, s(, Form1.nowPlaying.artist, , Form1.nowPlaying.file))
    If meta <> staticmeta Then
        newInternetStreamTags = True
        Form1.nowPlaying.song = meta
        staticmeta = meta
    End If
End Sub

Public Function getRadioTitle(ByVal channel As Long, Optional ByRef def As String) As String
    Dim info As BASS_CHANNELINFO
    If BASS_ChannelGetInfo(channel, info) = BASSTRUE Then
        If info.ctype = BASS_CTYPE_STREAM_OGG Then
            Dim oggstream As playItem
            Set oggstream = getStreamTags(channel)
            getRadioTitle = s2(oggstream.artist, " - ", oggstream.song) & _
                            s(" (", s2(oggstream.album, " - ", oggstream.year), ")")
        Else
            Dim meta As Long, tmpMeta As String
            If b(meta, BASS_ChannelGetTags(channel, BASS_TAG_META)) Then
                tmpMeta = VBStrFromAnsiPtr(meta)
                'StreamTitle='Golden Palominos - Pure';StreamUrl='http://www.radioparadise.com';
                If Mid$(tmpMeta, 1, 13) = "StreamTitle='" Then
                    tmpMeta = dec_UTF8(Mid$(tmpMeta, 14, InStr(tmpMeta, ";") - 15))
                    getRadioTitle = tmpMeta
                End If
            End If
        End If
    End If
    If LenB(getRadioTitle) = 0 Then getRadioTitle = def
End Function

Public Function Comdlg32CallbackP(ByVal hDlg As Long, ByVal msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Static Obj As io
    Select Case msg
    Case &H110: 'WM_INITDIALOG
        CopyMemory Obj, ByVal lParam + 64, 4
        Obj.Callback_WM_DIALOG 0, hDlg
    Case &H2: 'WM_DESTROY
        Obj.Callback_WM_DIALOG 1, 0
'    Case Else:
'        Debug.Print msg
    End Select
End Function
