Attribute VB_Name = "modSpectrum"
'    This file is part of Audica - Open Simple Audio Player.
'
'    Audica is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    Audica is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with Audica.  If not, see <http://www.gnu.org/licenses/>.

'/////////////////////////////////////////////////////////////////////////////////
' modSpectrum.bas - Copyright (c) 2002-2007 (: JOBnik! :) [Arthur Aminov, ISRAEL]
'                                                         [http://www.jobnik.org]
'                                                         [  jobnik@jobnik.org  ]
'
' Other source: frmSpectrum.frm
'
' Bass spectrum example
' Originally translated from - spectrum.c - Example of Ian Luck
'/////////////////////////////////////////////////////////////////////////////////

Option Explicit
Private Type WDM_COLORIZATION_PARAMS
    Color1 As Long
    Color2 As Long
    intensity As Long
    Unknown1 As Long
    Unknown2 As Long
    Unknown3 As Long
    Opaque As Long
End Type
Private Declare Sub DwmGetColorizationParameters Lib "dwmapi.dll" Alias "#127" (ByRef parameters As WDM_COLORIZATION_PARAMS)
Private Declare Sub DwmSetColorizationParameters Lib "dwmapi.dll" Alias "#131" (ByRef parameters As WDM_COLORIZATION_PARAMS, ByVal uUnknown As Long)
Dim p As WDM_COLORIZATION_PARAMS, special As Long, wdm_saved_color As Long, wdm_is_on As Boolean

Public Const BI_RGB = 0&
Public Const DIB_RGB_COLORS = 0&    ' color table in RGBs

Public Type BITMAPINFOHEADER
        biSize As Long
        biWidth As Long
        biHeight As Long
        biPlanes As Integer
        biBitCount As Integer
        biCompression As Long
        biSizeImage As Long
        biXPelsPerMeter As Long
        biYPelsPerMeter As Long
        biClrUsed As Long
        biClrImportant As Long
End Type

Public Type RGBQUAD
        rgbBlue As Byte
        rgbGreen As Byte
        rgbRed As Byte
        rgbReserved As Byte
End Type

Public Type BITMAPINFO
        bmiHeader As BITMAPINFOHEADER
        bmiColors(255) As RGBQUAD
End Type

Declare Sub FillMemory Lib "kernel32.dll" Alias "RtlFillMemory" (Destination As Any, ByVal length As Long, ByVal Fill As Byte)
Public Declare Function SetDIBitsToDevice Lib "GDI32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal dx As Long, ByVal dy As Long, ByVal SrcX As Long, ByVal SrcY As Long, ByVal Scan As Long, ByVal NumScans As Long, bits As Any, BitsInfo As BITMAPINFO, ByVal wUsage As Long) As Long
Private Declare Function StretchDIBits Lib "gdi32.dll" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal dx As Long, ByVal dy As Long, ByVal SrcX As Long, ByVal SrcY As Long, ByVal wSrcWidth As Long, ByVal wSrcHeight As Long, ByRef lpBits As Any, ByRef lpBitsInfo As BITMAPINFO, ByVal wUsage As Long, ByVal dwRop As Long) As Long

'' NOTE: Using an API MM timer (may sometimes Crash your app in an IDE mode)
'Public Const TIME_PERIODIC = 1  ' program for continuous periodic event
'Public Declare Function timeSetEvent Lib "winmm.dll" (ByVal uDelay As Long, ByVal uResolution As Long, ByVal lpFunction As Long, ByVal dwUser As Long, ByVal uFlags As Long) As Long
'Public Declare Function timeKillEvent Lib "winmm.dll" (ByVal uID As Long) As Long
'Public timing As Long       ' an API timer Handle

'Public Const SPECWIDTH As Long = 200  ' display width
Public SPECWIDTH As Long   ' display width
Public SPECREALWIDTH As Long   ' real display width
Public Const SPECHEIGHT As Long = 63 ' height (changing requires palette adjustments too)

'Public chan As Long         ' stream/music handle

'. 
Public Const SPECTRUM_UBOUND As Byte = 2
Public specmode As Long  ' spectrum mode
Public specbuf() As Byte    ' a pointer

Public bh As BITMAPINFO     ' bitmap header

Public colVol As New Collection

' MATH Functions
Public Function Sqrt(ByVal num As Double) As Double
    Sqrt = num ^ 0.5
End Function

Function Log10(ByVal x As Double) As Double
    Log10 = Log(x) / Log(10#)
End Function

Private Function freqBrightness(ByVal v As Single, ByVal led As Integer) As Boolean
    Static leds(2) As Integer, edge As Byte
'    If led = 0 Then edge = 3 Else edge = 2
    edge = 2
    inc leds(led)
    If leds(led) * v >= edge Then
        leds(led) = 0
        freqBrightness = True
    End If
End Function

' update the spectrum display - the interesting bit :)
Public Sub UpdateSpectrum(ByVal Handle As Long)
    Dim maxY As Long, maxy1 As Long
    Dim x As Long, y As Long, y1 As Long, i As Long
    
'    Dim lvl(2) As Long, tg As Long
'    lvl(2) = BASS_ChannelGetLevel(handle)
'    colVol.add (HiWord(lvl(2)) + LoWord(lvl(2))) / 2

'    lvl(0) = HiWord(lvl(2))
'    lvl(1) = LoWord(lvl(2))
'    lvl(2) = (HiWord(lvl(2)) + LoWord(lvl(2))) / 2
'    bh.bmiColors(0).rgbRed = bh.bmiColors(lvl(0) / 32768 * 62 + 1).rgbRed
'    bh.bmiColors(0).rgbGreen = bh.bmiColors(lvl(0) / 32768 * 62 + 1).rgbGreen
'    bh.bmiColors(0).rgbBlue = 0
'    tg = val(Form1.p.Tag)
'    Form1.p.Line (tg, 0)-(tg, Form1.p.ScaleHeight \ 2) , RGB(bh.bmiColors(lvl(0) / 32768 * 62 + 1).rgbRed, bh.bmiColors(lvl(0) / 32768 * 62 + 1).rgbGreen, 0)
'    Form1.p.Line (tg, Form1.p.ScaleHeight \ 2)-(tg, Form1.p.ScaleHeight), RGB(bh.bmiColors(lvl(1) / 32768 * 62 + 1).rgbRed, bh.bmiColors(lvl(1) / 32768 * 62 + 1).rgbGreen, 0)
'    If tg < Form1.p.ScaleWidth Then
'        Form1.p.Tag = tg + 1
'    Else
'        Form1.p.Cls
'        Form1.p.Tag = 0
'    End If

    If wdm_is_on Then
        Dim level As Long
        Static prev As Long
        level = BASS_ChannelGetLevel(Handle)
        level = ((HiWord(level) + LoWord(level)) / 2) \ 128
        If level = 256 Then level = 255 'Cap it.
        If level - prev > 50 Then level = prev + 50 Else If prev - level > 50 Then level = prev - 50 'Smoother.
        If level < 128 Then
            p.Color1 = special + RGB(0, 128 + level, level * 2)
        Else
            p.Color1 = special + RGB(0, 256 - (level - 127) * 2, 255)
        End If
        p.Color2 = p.Color1
'        Debug.Print p.Color1
        DwmSetColorizationParameters p, 0
        prev = level
    End If
    
    If (specmode = 2) Then ' waveform
        Dim C As Long, buf() As Single, ci As BASS_CHANNELINFO
        ReDim specbuf(SPECWIDTH * (SPECHEIGHT + 1)) As Byte ' clear display

        Call BASS_ChannelGetInfo(Handle, ci) ' get number of channels
        ReDim buf(ci.chans * SPECWIDTH * LenB(buf(0))) As Single  ' allocate buffer for data

        Call BASS_ChannelGetData(Handle, buf(0), (ci.chans * SPECWIDTH * LenB(buf(0))) Or BASS_DATA_FLOAT)  ' get the sample data (floating-point to avoid 8 & 16 bit processing)
        For C = 0 To ci.chans - 1
            For x = 0 To SPECWIDTH - 1
                Dim v As Long
                v = (1 - buf(x * ci.chans + C)) * SPECHEIGHT / 2 ' invert and scale to fit display
                If (v < 0) Then
                    v = 0
                ElseIf (v >= SPECHEIGHT) Then
                    v = SPECHEIGHT - 1
                End If
                If (x = 0) Then
                    y = v
                    For i = 0 To v
                        specbuf(i * SPECWIDTH) = IIf(C And 1, 66, 65) ' draw level
                    Next i
                End If
                If (x = SPECWIDTH - 1) Then
                    For i = 0 To v
                        specbuf(i * SPECWIDTH + SPECWIDTH - 1) = IIf(C And 1, 66, 65) ' draw level
                    Next i
                End If
                Do  ' draw line from previous sample...
                    If (y < v) Then
                        incr y
                    ElseIf (y > v) Then
                        decr y
                    End If
                    specbuf(y * SPECWIDTH + x) = IIf(C And 1, 66, 65) ' left=green, right=red (could add more colours to palette for more chans)
                Loop While (y <> v)
            Next x
        Next C
    Else
        Dim fft(1023) As Single     ' get the FFT data
        Call BASS_ChannelGetData(Handle, fft(0), BASS_DATA_FFT2048)

'--LEDS--
        If LEDControl And Not kbd_presses Then
            Dim d(2) As Single, z As Integer
'            For z = 1 To 341
'                d(0) = d(0) + fft(z)
'                d(1) = d(1) + fft(z + 341)
'                d(2) = d(2) + fft(z + 682)
'            Next z
            For z = 1 To 9
                d(0) = d(0) + fft(z)
            Next z
            For z = 0 To 130
                d(1) = d(1) + fft(z + 70)
            Next z
            d(1) = d(1) - 0.6
            For z = 0 To 400
                d(2) = d(2) + fft(z + 623)
            Next z
            d(2) = d(2) * 1.5
            Call setLEDs(freqBrightness(d(2), 2), _
                        freqBrightness(d(0), 0), _
                        freqBrightness(d(1), 1))
        End If
'--LEDS--

        If (specmode = 0) Then ' "normal" FFT
            ReDim specbuf(SPECWIDTH * (SPECHEIGHT + 1)) As Byte ' clear display
            Call FillMemory(specbuf(0), SPECWIDTH, 1) '  
            For x = 0 To (SPECWIDTH / 2) ' - 1
                y = Sqrt(fft(x + 1)) * 3 * SPECHEIGHT - 4 ' scale it (sqrt to make low values more visible)
'                Y = fft(x + 1) * 10 * SPECHEIGHT ' scale it (linearly)
                If (y > SPECHEIGHT) Then y = SPECHEIGHT ' cap it
                If (x) Then  ' interpolate from previous to make the display smoother
                    y1 = (y + y1) / 2
                    maxY = y1
                    y1 = y1 - 1
                    While (y1 >= 0)
                        specbuf(y1 * SPECWIDTH + x * 2 - 1) = maxY 'y1 + 1
                        y1 = y1 - 1
                    Wend
                End If
                y1 = y
                maxY = y
                y = y - 1
                While (y >= 0)
                    specbuf(y * SPECWIDTH + x * 2) = maxY 'Y + 1  ' draw level
                    y = y - 1
                Wend
            Next x
        ElseIf (specmode = 1) Then   ' logarithmic, acumulate & average bins
            ReDim specbuf(SPECWIDTH * (SPECHEIGHT + 1)) As Byte ' clear display
            Dim b0 As Long, BANDS As Integer
            b0 = 0
            BANDS = SPECWIDTH \ 5
            Dim sc As Long, b1 As Long
            Dim sum As Single
            For x = 0 To BANDS - 1
                Call FillMemory(specbuf(x * Int(SPECWIDTH / BANDS)), _
                    SPECWIDTH / BANDS - 1, 1) '  
                sum = 0
                b1 = 2 ^ (x * 10# / (BANDS - 1))
                If (b1 > 1023) Then b1 = 1023
                If (b1 <= b0) Then b1 = b0 + 1 ' make sure it uses at least 1 FFT bin
                sc = 10 + b1 - b0
                Do
                    sum = sum + fft(1 + b0)
                Loop While incr(b0) < b1
                y = (Sqrt(sum / Log10(sc)) * 1.7 * SPECHEIGHT) - 4 ' scale it
                If (y > SPECHEIGHT) Then y = SPECHEIGHT ' cap it
                maxY = y
                y = y - 1
                While (y >= 0)
                    Call FillMemory(specbuf(y * SPECWIDTH + x * Int(SPECWIDTH / BANDS)), SPECWIDTH / BANDS - 1, maxY)
                    y = y - 1
                Wend
            Next x
        End If
    End If

    ' update the display
    ' to display in a PictureBox, simply change the .hDC to Picture1.hDC :)
'    Call SetDIBitsToDevice(Form1.box_spectr.hdc, 0, 0, SPECWIDTH, SPECHEIGHT, 0, 0, 0, SPECHEIGHT, specbuf(0), bh, 0)
    Call StretchDIBits(Form1.box_spectr.hdc, 0, 0, SPECREALWIDTH, SPECHEIGHT, 0, 0, SPECWIDTH, SPECHEIGHT, specbuf(0), bh, 0, vbSrcCopy)
End Sub

Public Sub InitSpectrum(ByVal spWidth As Long, ByVal backclr As Long)
    Dim a As Byte
    
    SPECWIDTH = spWidth

    ' create bitmap to draw spectrum in - 8 bit for easy updating :)
    With bh.bmiHeader
        .biBitCount = 8
        .biPlanes = 1
        .biSize = Len(bh.bmiHeader)
        .biWidth = SPECWIDTH
        .biHeight = SPECHEIGHT  ' upside down (line 0=bottom)
        .biClrUsed = 256
        .biClrImportant = 256
    End With

    ' setup palette
    bh.bmiColors(0).rgbRed = backclr And 255
    bh.bmiColors(0).rgbGreen = backclr \ 256 And 255
    bh.bmiColors(0).rgbBlue = backclr \ 65536 And 255
    
    bh.bmiColors(64).rgbRed = cColor(&H80000000) And 255
    bh.bmiColors(64).rgbGreen = cColor(&H80000000) \ 256 And 255
    bh.bmiColors(64).rgbBlue = cColor(&H80000000) \ 65536 And 255
    
    For a = 1 To 63
        bh.bmiColors(a).rgbGreen = 224 - 7 * IIf(a <= 32, 0, a - 32)
        bh.bmiColors(a).rgbRed = 7 * IIf(a <= 32, a, 32)
    Next a
    
    bh.bmiColors(65).rgbGreen = 240
    bh.bmiColors(66).rgbRed = 240
End Sub

Public Sub reWidthSpec(ByVal spWidth As Long)
    SPECREALWIDTH = spWidth
    spWidth = (spWidth \ 16) * 16
    SPECWIDTH = spWidth
    bh.bmiHeader.biWidth = spWidth
End Sub

Public Sub RestoreWDMColor()
    If wdm_is_on Then
        p.Color1 = special + wdm_saved_color
        p.Color2 = p.Color1
        DwmSetColorizationParameters p, 0
    End If
End Sub

Public Sub UnInitWDM()
    Call RestoreWDMColor
    wdm_is_on = False
End Sub

Public Sub InitWDM()
On Error GoTo 1:
    DwmGetColorizationParameters p
    special = Sgn(p.Color1) * (p.Color1 And &HFF000000)
    wdm_saved_color = p.Color1 And &HFFFFFF
    wdm_is_on = True
Exit Sub
1: qError "Cannot initializate WDM."
End Sub

Public Function WDMIsReady() As Boolean
On Error GoTo 1:
    Dim ret As WDM_COLORIZATION_PARAMS
    DwmGetColorizationParameters ret
    WDMIsReady = True
1:
End Function

