VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "tabsClass"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'    Copyright 2009, 2010 Makarov Andrey
'
'    This file is part of Audica - Open Simple Audio Player.
'
'    Audica is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    Audica is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with Audica.  If not, see <http://www.gnu.org/licenses/>.

Option Explicit
Private Const NO_PLAYINGLIST As Integer = -2
Public NO_DEFAULT As Integer '= -1
Private Const TAB_CNT As Integer = 14

Private activeLst As Integer
Private defaultLst As Integer
Public playingID As Integer '     
                            '    
Public clickID As Integer 'ID   
                            '(    mousedown, mouseup)
Public dragging As Boolean '  
Private tabCol As New Collection ' 
Private trash As frm_plst '

Private tab_cont As Object
Attribute tab_cont.VB_VarHelpID = -1
Private tab_parent_wnd As Long
Private Declare Function GetParent Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetWindowRect Lib "user32.dll" (ByVal hwnd As Long, lpRect As RECT) As Long

Private Declare Function SetFocus Lib "user32.dll" (ByVal hwnd As Long) As Long

Private Declare Function SetParent Lib "user32" (ByVal hWndChild As Long, ByVal hWndNewParent As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Const GWL_STYLE = -16
Const WS_CHILD = &H40000000
Const WS_CHILDWINDOW = (WS_CHILD)
Const WS_CLIPCHILDREN = &H2000000

Public Property Get Container() As Object
    Set Container = tab_cont
End Property

'WRAPPER: Adds and activates new tab
Public Function Create() As Boolean
    If Add Then       '  
        Call Activate(hBound)
        Create = True
    End If
End Function

'WRAPPER: Deletes tab \ind\ and activates another tab
Public Sub Delete(ByVal ind As Integer)
    Dim ttab As Integer
    If Remove(ind) Then
        If ind < activeID Then ttab = _
            activeID - 1 _
        Else ttab = IIf(activeID > hBound, _
            hBound, _
            activeID)
        Call show(ttab)
    End If
End Sub

'WRAPPER: Hides active playlist and shows playlist \ind\
Public Sub Activate(ByVal ind As Integer)
    If Not activeID = ind Then
        Call hide(activeID)   '  
        Call show(ind)  ' 
    End If
End Sub

'Create new playlist
'RV: \true\ if no errors and tabs < TAB_CNT
Public Function Add() As Boolean
On Error GoTo 1:
    Dim frm As New frm_plst
    If Count = TAB_CNT Then '  TAB_CNT 
        qError "Can't add more than " & TAB_CNT & " tabs"
        Exit Function
    End If
    tabCol.Add frm
    frm.title = time
    frm.id = hBound
    SetParent frm.hwnd, tab_parent_wnd
    SetWindowLong frm.hwnd, GWL_STYLE, WS_CHILDWINDOW Or WS_CLIPCHILDREN
    SetFocus tab_parent_wnd
    Add = True
1:
End Function

'Delete frm
'RV: \true\ if \ind\ frm found
Private Function Remove(ByVal ind As Integer) As Boolean
On Error GoTo 1
    Dim frm As frm_plst
    If Not inBounds(ind, 0, hBound) Or Count = 1 Then Exit Function '   
    If default = ind Then default = NO_DEFAULT
    If playingID = ind Then playingID = NO_PLAYINGLIST
    Unload getOne(ind)
    tabCol.Remove ind + 1
    Call repairIndex
    Remove = True
Exit Function
1: con.WriteLine "Tabs.remove error", d_ERROR
End Function

'Show playlist frm
Private Sub show(ByVal ind As Integer)
    Dim frm As frm_plst
    Set frm = getOne(ind)
    If Not frm Is Nothing Then
        Call mov(frm)
        frm.show
        activeLst = ind
        draw
        Call getOne(ind).signalUpdateListInfo
    End If
End Sub

Public Sub Sort(ByVal id As Integer, ByVal newID As Integer)
    If inBounds(id, 0, hBound) And inBounds(newID, 0, hBound) And id <> newID Then
        Dim tmp As frm_plst
        Set tmp = tabCol(id + 1)
        tabCol.Remove id + 1
        If id < newID Then
            tabCol.Add tmp, , , (newID + 1) - 1
        Else
            tabCol.Add tmp, , (newID + 1)
        End If
        Call repairIndex
        If defaultLst = id Then defaultLst = newID
        Activate newID
        draw
    Else
        con.WriteLine "Wrong tab ids to sort: {0} and {1}", d_ERROR, id, newID
    End If
End Sub

' id      
'id   , 
Private Sub repairIndex()
    Dim i As Integer
    For i = 1 To tabCol.Count
        tabCol(i).id = i - 1
    Next i
End Sub

Public Property Get tabs() As Collection
    Set tabs = tabCol
End Property

'Hide playlist frm
Private Sub hide(ByVal ind As Integer)
    Dim frm As frm_plst
    Set frm = getOne(ind)
    If Not frm Is Nothing Then
        frm.hide
        Exit Sub
    End If
End Sub

'Get playlist frm with \ind\ ID
'RV: found form object
Public Function getOne(ByVal ind As Integer) As frm_plst
    If Not inBounds(ind, -1, hBound) Then Exit Function
    If ind <> -1 Then
        Set getOne = tabCol(ind + 1)
    Else
        Set getOne = trash
    End If
End Function

'Get active playlist frm
'RV: active frm object
Public Function active() As frm_plst
    Set active = getOne(activeID)
End Function

'ID of active frm
'RV: active frm ID
Public Property Get activeID() As Long
    activeID = activeLst
End Property

'Get frm which has playing track
'RV: playing frm object
Public Function playing() As frm_plst
    If playingID <> NO_PLAYINGLIST Then _
        Set playing = getOne(playingID)
End Function

'Get playlist count
'RV: number of frms
Public Property Get Count() As Integer
    Count = tabCol.Count
End Property

'Get high bound frm ID
'RV: max ID
Public Property Get hBound() As Integer
    hBound = tabCol.Count - 1
End Property

'ID of default frm
'RV: default frm ID
Public Property Get default() As Integer
    default = defaultLst
End Property

'Sets default frm
Public Property Let default(ByVal ind As Integer)
    defaultLst = ind
End Property

'  (    )
Public Property Let name(ByVal ind As Integer, ByVal str As String)
    If Not inBounds(ind, 0, hBound) Then Exit Property
    getOne(ind).title = str
    Call draw
End Property

Public Property Get name(ByVal ind As Integer) As String
    name = getOne(ind).title
End Property

'Init
'/tab_cont_/ is a object, where tabs are drawn
Public Sub init(tab_cont_ As Object, tab_parent_wnd_ As Long)
    Set tab_cont = tab_cont_
    tab_parent_wnd = tab_parent_wnd_
    
    Set trash = New frm_plst
    SetParent trash.hwnd, tab_parent_wnd
    SetWindowLong trash.hwnd, GWL_STYLE, WS_CHILDWINDOW Or WS_CLIPCHILDREN Or WS_CHILD
'    tabCol.add frm
    trash.id = -1
    
    tabCol.Add New frm_plst
    SetParent tabCol(1).hwnd, tab_parent_wnd
    SetWindowLong tabCol(1).hwnd, GWL_STYLE, WS_CHILDWINDOW Or WS_CLIPCHILDREN Or WS_CHILD
    tabCol(1).title = time
    
'    Call mov(web)
    tabCol(1).show
    Call draw
    Call tabCol(1).signalUpdateListInfo
End Sub

Public Sub draw(Optional hilight As Integer = -1)
With tab_cont
    Dim i As Integer, tabwdt As Integer, str As String, id As Integer, rc As RECT
    .Cls
    tab_cont.Line (0, 0)-(.ScaleWidth, 0), &HA0A0A0
    tab_cont.Line (.ScaleWidth - 1, 0)-(.ScaleWidth - 1, .ScaleHeight), vbWhite
    tabwdt = .Width \ Count
    For i = 0 To .Width - tabwdt Step tabwdt
        id = i \ tabwdt
        str = getOne(id).title
        .ForeColor = IIf(activeLst = id, C_TabsActiveFore, C_TabsFore)
        .FontSize = appropFontSize(str, tab_cont, tabwdt, 10 + 4)
        rc.Left = i + 10
        rc.Top = .Height \ 2 - .TextHeight(str) \ 2
        rc.Bottom = .Height
        rc.Right = i + tabwdt - 4
        prtf .hdc, str, rc
'        prt .hdc, str, i + 10, .Height \ 2 - .TextHeight(str) \ 2
                
        If i Then
            tab_cont.Line (i + 3, 1)-(i + 1, 3), &HE0E0E0
            tab_cont.Line (i + 1, 3)-(i + 1, .ScaleHeight), &HE0E0E0
        End If
        If activeLst = id Then
            tab_cont.Line (i, .ScaleHeight - 2)-(IIf(id <> hBound, i + tabwdt, .ScaleWidth - 2), .ScaleHeight - 1), &H80FF&, BF
        ElseIf hilight = id Then
            tab_cont.Line (i, .ScaleHeight - 2)-(IIf(id <> hBound, i + tabwdt, .ScaleWidth - 2), .ScaleHeight - 1), &H808080, BF
        End If
            
        tab_cont.Line (i + IIf(i, 2, 0), 1)-(i, 3), &HA0A0A0
        tab_cont.Line (i, 3)-(i, .ScaleHeight), &HA0A0A0
    Next i
End With
End Sub

'Finds best font size (6-12) for current \wdt\ width and font of \cont\
Private Function appropFontSize(ByRef str As String, ByRef cont As Object, ByVal wdt As Integer, Optional offset As Integer = 0) As Integer
    Dim i As Integer, fnt As Integer
    fnt = cont.FontSize
    For i = 7 To 13
        cont.FontSize = i
        If cont.TextWidth(str) > wdt - offset Then Exit For
    Next i
    cont.FontSize = fnt
    appropFontSize = i - 1
End Function

Public Sub mov(playlist As frm_plst)
    Dim W As Long, H As Long, rc As RECT
    Call GetWindowRect(GetParent(playlist.hwnd), rc)
    W = rc.Right - rc.Left
    H = rc.Bottom - rc.Top
    playlist.Move 0, 0, W * Screen.TwipsPerPixelX, H * Screen.TwipsPerPixelY
End Sub

Private Sub Class_Initialize()
    NO_DEFAULT = -1
    default = NO_DEFAULT
    playingID = NO_PLAYINGLIST
End Sub
