VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsScript"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'    Copyright 2010 Makarov Andrey
'
'    This file is part of Audica Upload Tool (Audica service program).
'
'    Audica is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    Audica is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with Audica.  If not, see <http://www.gnu.org/licenses/>.

Option Explicit
Private WithEvents Script As ScriptControl
Attribute Script.VB_VarHelpID = -1
Private WshShell As Object
'Private Script As Object

Private Sub Class_Initialize()
    Set WshShell = CreateObject("WScript.Shell")
'    Set Script = CreateObject("ScriptControl")
    Set Script = New ScriptControl
    Script.Timeout = 60000
    Language = "VBScript"
    
'    Set WshFSO = CreateObject("Scripting.FileSystemObject")
'    Script.AddObject "WshFSO", WshFSO
End Sub

Public Sub ExecuteStatement(ByRef statement As String)
    Script.ExecuteStatement statement
End Sub

Public Sub AddObject(ByRef obj As Object, Optional ByVal name As String)
    If name = "" Then
        Script.AddObject obj.name, obj
    Else
        Script.AddObject name, obj
    End If
End Sub

Public Function Eval(ByRef expression As String) As Variant
    Eval = Script.Eval(expression)
End Function

Public Sub AddCode(ByRef code As String)
    Script.AddCode code
End Sub

Public Function Run(ByVal func As String, ParamArray args() As Variant) As Variant
On Error GoTo 1
    Select Case UBound(args)
    Case -1: Run = Script.Run(func)
    Case 0: Run = Script.Run(func, args(0))
    Case 1: Run = Script.Run(func, args(0), args(1))
    Case 2: Run = Script.Run(func, args(0), args(1), args(2))
    Case 3: Run = Script.Run(func, args(0), args(1), args(2), args(3))
    End Select
Exit Function
1: 'MsgBox "Can't run script", vbCritical
End Function

Public Property Let Language(ByRef lang As String)
    Script.Language = lang
    Script.Reset
    Script.UseSafeSubset = False
    Script.AddObject "WshShell", WshShell
End Property

Private Sub Script_Error()
    Dim Error As Error
    Set Error = Script.Error
    MsgBox "Error #" & Error.Number & " - " & Error.Description & vbNewLine & _
    "Position: " & Error.Line & "," & Error.Column, vbCritical, "Script Error"
    End '   - 
End Sub

Public Property Let Timeout(ByVal tout As Long)
    Script.Timeout = tout
End Property

Private Sub Script_Timeout()
'NOT WORKING. WHY??
    MsgBox "Script timeout", vbExclamation
    End '   - 
'---
End Sub
