Attribute VB_Name = "upload_main"
'    Copyright 2010 Makarov Andrey
'
'    This file is part of Audica Upload Tool (Audica service program).
'
'    Audica is free software: you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation, either version 3 of the License, or
'    (at your option) any later version.
'
'    Audica is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with Audica.  If not, see <http://www.gnu.org/licenses/>.

Option Explicit
Private Declare Function PathFileExistsW Lib "shlwapi.dll " (ByVal pszPath As Long) As Boolean
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function CommandLineToArgvW Lib "shell32.dll" (ByVal nInput As Long, ByRef retcount As Long) As Long
Private Declare Function SysAllocString Lib "oleaut32" (ByVal nString As Long) As Long
Private Declare Function LocalFree Lib "kernel32.dll" (ByVal hMem As Long) As Long
Private Declare Function GetCommandLine Lib "kernel32.dll" Alias "GetCommandLineW" () As Long
Private Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (ByVal Destination As Any, ByVal Source As Any, ByVal Length As Long)
Private XMLHTTP As Object, WinHttp As Object, WebForm As HttpFormClass
Private Script As New clsScript
Const UPLOAD_DEFAULT_SCRIPT As String = "upload_rghost.vbs"
Private UPLOAD_SCRIPT As String

Sub Main()
On Error GoTo 1
    Dim scr As String, ret As String, cmdline() As String, cmd As String
    ChDir App.Path
    ChDrive App.Path
    
    Load Form1
    cmdline = CommandLine()
    Select Case UUBound(cmdline)
    Case Is < 1: Err.Raise -1, , "Command line is empty"
    Case Is > 1:
        If cmdline(1) = "$choose" Then
            UPLOAD_SCRIPT = Form1.ChooseScriptFile
            If UPLOAD_SCRIPT = "" Then End  'Script not choosed
        Else
            UPLOAD_SCRIPT = cmdline(1) 'Take script from command line
        End If
    Case Is = 1: UPLOAD_SCRIPT = ReadSetting("Upload", "Script", UPLOAD_DEFAULT_SCRIPT) 'Take script from options.ini
    End Select
    cmd = cmdline(UUBound(cmdline))
    If Not PathFileExistsW(StrPtr(cmd)) Then Err.Raise -5, , "Cannot find file " & cmd

    Script.Timeout = ReadSetting("Upload", "Timeout", 60000)
    If Dir$(UPLOAD_SCRIPT) = "" Then Err.Raise -2, , "Can't find uploading script " & UPLOAD_SCRIPT
    If UPLOAD_SCRIPT Like "*.vbs" Then
        Script.Language = "VBScript"
    ElseIf UPLOAD_SCRIPT Like "*.js" Then
        Script.Language = "JScript"
    Else
        Err.Raise -4, , "Script is not VBScript or JScript"
    End If
    Open UPLOAD_SCRIPT For Binary Access Read As #1
    scr = Space(LOF(1))
    Get #1, , scr
    Close #1

    Set XMLHTTP = CreateObject("MSXML2.XMLHTTP")
    Set WinHttp = CreateObject("WinHttp.WinHttpRequest.5.1")
    Set WebForm = New HttpFormClass
    Script.AddObject XMLHTTP, "XMLHTTP"
    Script.AddObject WinHttp, "WinHttp"
    Script.AddObject WebForm, "WebForm"
    Script.AddCode scr
    ret = Script.Run("upload", cmd)
    Set XMLHTTP = Nothing
    Set WinHttp = Nothing
    Set WebForm = Nothing

    Set Script = Nothing

    If ret = "" Then Err.Raise -3, , "Upload script returned nothing"
    Form1.Text2.Text = cmd
    Form1.Text1.Text = ret
    Form1.Show
    Form1.Text1.SetFocus
Exit Sub
1:  MsgBox Err.Number & " - " & Err.Description, vbCritical, "Upload error"
    Unload Form1
End Sub

'Get command line arguments
Private Function CommandLine() As String()
    Dim ret As Long, retcount As Long, rt() As String, i As Integer, lng As Long
    ret = CommandLineToArgvW(GetCommandLine(), retcount)
    If retcount > 0 Then
        ReDim rt(retcount - 1)
        For i = 0 To UBound(rt)
            CopyMemory VarPtr(lng), ret + i * 4, 4
            CopyMemory VarPtr(rt(i)), VarPtr(SysAllocString(lng)), 4
        Next i
        CommandLine = rt
    End If
    If ret <> 0 Then LocalFree ret
End Function

Private Function inIDE() As Boolean
On Error GoTo 1:
    Debug.Print 1 / 0
Exit Function
1:  inIDE = True
End Function

Public Function UUBound(arr) As Long
On Error GoTo 1:
    UUBound = UBound(arr)
Exit Function
1:  UUBound = -1
End Function

Public Function ReadSetting(SekName As String, KeyName As String, DefaultVal As String, Optional IniFileName As String) As String
    Dim sTemp As String * 556, nTemp As Integer
    nTemp = GetPrivateProfileString(SekName, KeyName, DefaultVal, sTemp, 555, AppPath & IIf(IniFileName = "", "options.ini", IniFileName))
    ReadSetting = Left$(sTemp, nTemp)
End Function

Public Function AppPath() As String
    If Right(App.Path, 1) <> "\" Then AppPath = App.Path & "\" Else AppPath = App.Path
End Function

'Private Function CommandLine() As String
'    If inIDE Then CommandLine = Command$: Exit Function
'
'    Dim Buffer(511) As Byte, pointer As Long
'    Dim p1 As Long, p2 As Long, found As Boolean
'    pointer = GetCommandLine()
'    CopyMemory Buffer(0), ByVal pointer, 512
'    CommandLine = Trim$(CStr(Buffer))
'    p1 = InStr(1, CommandLine, Chr$(0))
'    If p1 Then CommandLine = Left$(CommandLine, p1 - 1)
'    If Right$(CommandLine, 1) <> """" Then  '  
'        p1 = -1
'        p2 = InStrRev(CommandLine, " ")
'        If p2 Then
'            CommandLine = Mid$(CommandLine, p2 + 1)
'            found = True
'        End If
'    Else    '  
'        p1 = InStrRev(CommandLine, """")
'        If p1 > 1 Then
'            p1 = p1 - 1
'            p2 = InStrRev(CommandLine, """", p1)
'            If p2 < p1 Then
'                CommandLine = Mid$(CommandLine, p2 + 1, p1 - p2)
'                found = True
'            End If
'        End If
'    End If
'    If Not found Then CommandLine = "" ' 
'End Function
